property spriteNum, kakudo, kakudoIndex, index, index2, palette, center, amplitude
global gParameter

on beginSprite me
  me.palette = value(member("paletteRaster").text)
  me.kakudo = value(member("theta").text)
  initialize(me)
end

on initialize me
  me.kakudoIndex = me.spriteNum mod count(me.kakudo)
  me.index = me.spriteNum mod count(me.palette)
  me.index2 = me.spriteNum mod count(me.palette)
  me.center = the stageRight - the stageLeft / 2
  setparam(me, 32)
  nextstate(me)
end

on exitFrame me
  nextstate(me)
end

on nextstate me
  if me.index < count(me.palette) then
    me.index = me.index + 1
  else
    me.index = 1
  end if
  if me.index2 > 1 then
    me.index2 = me.index2 - 1
  else
    me.index2 = count(me.palette)
  end if
  if me.kakudoIndex < count(me.kakudo) then
    me.kakudoIndex = me.kakudoIndex + 1
  else
    me.kakudoIndex = 1
  end if
  h = abs(the mouseH - me.center)
  set the foreColor of sprite the spriteNum of me to getAt(me.palette, me.index)
  set the backColor of sprite the spriteNum of me to getAt(me.palette, me.index2)
  set the locH of sprite the spriteNum of me to me.center + me.amplitude * cos(getAt(me.kakudo, me.kakudoIndex))
end

on setparam me, inParam
  me.amplitude = inParam
end
