property truewidth, trueheight, mywidth, myheight, myangle, anglestep, stepnum, showstate, sizechangestep, myuserinfolist, myspritenum

on new me, vlist, snum
  myuserinfolist = vlist
  myspritenum = snum
  truewidth = 48
  trueheight = 48
  mywidth = 1
  myheight = 1
  myangle = 0
  showstate = #showing
  sprite(myspritenum).width = mywidth
  sprite(myspritenum).height = myheight
  sprite(myspritenum).rotation = myangle
  updateStage()
  sizechangestep = 4
  stepnum = truewidth - mywidth / sizechangestep
  anglestep = 720 / stepnum
  sprite(myspritenum).visible = 1
  return me
end

on exitFrame me
  case showstate of
    #showing:
      mywidth = mywidth + sizechangestep
      myheight = myheight + sizechangestep
      myangle = myangle + anglestep
      if mywidth >= truewidth then
        mywidth = truewidth
        myheight = trueheight
        showstate = #show
        myangle = 0
      end if
      sprite(myspritenum).width = mywidth
      sprite(myspritenum).height = myheight
      sprite(myspritenum).rotation = myangle
    #hiding:
      mywidth = mywidth - sizechangestep
      myheight = myheight - sizechangestep
      myangle = myangle - anglestep
      if mywidth <= 1 then
        mywidth = 1
        myheight = 1
        showstate = #show
        myangle = 0
        erase(member("name" & stringtonum(myuserinfolist.userid)))
        sprite(myspritenum).scriptInstanceList = []
        sprite(myspritenum).type = 0
        puppetSprite(myspritenum, 0)
        sprite(myspritenum - 1).type = 0
        puppetSprite(myspritenum - 1, 0)
        sprite(myspritenum + 1).type = 0
        puppetSprite(myspritenum + 1, 0)
        sendAllSprites(#deletemylist, myuserinfolist.userid)
        sendAllSprites(#resetcharapos)
      end if
      sprite(myspritenum).width = mywidth
      sprite(myspritenum).height = myheight
      sprite(myspritenum).rotation = myangle
    #otherwise:
      nothing()
  end case
end

on deleteme me
  mywidth = truewidth
  myheight = trueheight
  sprite(myspritenum).width = mywidth
  sprite(myspritenum).height = myheight
  sprite(myspritenum).rotation = 0
  showstate = #hiding
end
