property charalist, firstcharasnum, firstcharaloc, nextcharawidth, textoffset, maxcharanum, scrollnum, pminwidth, pminheight
global guser

on beginSprite me
  charalist = []
  firstcharasnum = 60
  firstcharaloc = point(64, 73)
  nextcharawidth = 80
  textoffset = point(-43, 24)
  me.maxcharanum = 0
  me.scrollnum = 0
  me.pminwidth = the stageRight - the stageLeft
  me.pminheight = the stageBottom - the stageTop
end

on exitFrame
  go(the frame)
end

on setstatus me, vlist
  testnum = 0
  repeat with i = 1 to charalist.count
    if equal(charalist[i].userid, vlist.userid) then
      testnum = i
    else
    end if
  end repeat
  if testnum = 0 then
    tmp = 0
    repeat while 1
      tmpsnum = firstcharasnum + tmp
      if sprite(tmpsnum).type = 0 then
        newsnum = tmpsnum
        exit repeat
      else
        tmp = tmp + 1
      end if
    end repeat
    add(charalist, [#userid: vlist.userid, #snum: newsnum])
    newpos = searchmypos(me, charalist.count)
    setsprite(newsnum, 0, 255, 0, "dummy", newpos, 1)
    setsprite(newsnum + 1, 36, 255, 40, "dummy", newpos, 1)
    add(sprite(newsnum + 1).scriptInstanceList, new(script("キャラ表示"), vlist, newsnum + 1))
    newmember = new(#field)
    member(newmember).name = "name" & stringtonum(vlist.userid)
    rect = member(newmember).rect
    rect.right = 86
    member(newmember).rect = rect
    member(newmember).alignment = "center"
    member(newmember).text = vlist.userid
    setsprite(newsnum + 2, 36, 255, 0, member(newmember).name, newpos + textoffset, 1)
    checkscrollbutton(me)
    if objectp(guser) then
      if guser.getsound() then
        if not soundBusy(2) then
          puppetSound(2, "roomenter")
        end if
      end if
    end if
  else
    spnum = charalist[testnum].snum + 1
    sendSprite(spnum, #setstatusid, vlist)
  end if
end

on retire me, vlist
  tmplist = []
  repeat with i = 1 to me.count(#charalist)
    if equal(me.charalist[i].userid, vlist.userid) then
      tmplist = me.charalist[i]
    else
    end if
  end repeat
  if tmplist = [] then
    nothing()
  else
    sendSprite(tmplist.snum + 1, #deleteme)
  end if
  if objectp(guser) then
    if guser.getsound() then
      if not soundBusy(2) then
        puppetSound(2, "roomexit")
      end if
    end if
  end if
end

on searchmypos me, vnum
  return firstcharaloc + point(nextcharawidth, 0) * vnum + me.scrollnum - 1
end

on deletemylist me, vid
  repeat with i = 1 to charalist.count
    if equal(charalist[i].userid, vid) then
      deleteAt(charalist, i)
    end if
  end repeat
end

on resetcharapos me
  repeat with i = 1 to charalist.count
    tmppos = searchmypos(me, i)
    tmpsnum = charalist[i].snum
    sprite(tmpsnum + 0).loc = tmppos
    sprite(tmpsnum + 1).loc = tmppos
    sprite(tmpsnum + 2).loc = tmppos + textoffset
  end repeat
  checkscrollbutton(me)
end

on scrollchara me, vnum
  me.scrollnum = me.scrollnum + vnum
  repeat with i = 1 to me.count(#charalist)
    tmpsnum = me.charalist[i].snum
    sprite(tmpsnum + 0).locH = sprite(tmpsnum + 0).locH + me.nextcharawidth * vnum
    sprite(tmpsnum + 1).locH = sprite(tmpsnum + 1).locH + me.nextcharawidth * vnum
    sprite(tmpsnum + 2).locH = sprite(tmpsnum + 2).locH + me.nextcharawidth * vnum
  end repeat
  checkscrollbutton(me)
end

on setmaxcharanum me
  me.maxcharanum = the stageRight - the stageLeft - 68 - 48 / 80 + 1
  checkscrollbutton(me)
end

on checkscrollbutton me
  if me.maxcharanum - me.scrollnum + 1 > me.count(#charalist) then
    sendAllSprites(#hidescrollrightbutton)
  else
    sendAllSprites(#showscrollrightbutton)
  end if
  if me.scrollnum + 1 > 0 then
    sendAllSprites(#hidescrollleftbutton)
  else
    sendAllSprites(#showscrollleftbutton)
  end if
end

on setminsize me
  stagewidth = the stageRight - the stageLeft
  stageheight = the stageBottom - the stageTop
  tmprect = the activeWindow.rect
  if stagewidth < me.pminwidth then
    p3 = tmprect[1] + me.pminwidth
  else
    p3 = tmprect[3]
  end if
  if stageheight < me.pminheight then
    p4 = tmprect[2] + me.pminheight
  else
    p4 = tmprect[4]
  end if
  tmprect = rect(tmprect[1], tmprect[2], p3, p4)
  the activeWindow.rect = tmprect
end
