property myuserinfolist, myemotionlist, charaid, charastate, firstimageoffset, loopcountlist, loopstartlist, firstcast, lastcast, mycount, lastticks, animdata, stopanim, myspritenum, status
global gnewmessage, guser, gcharacter

on new me, vlist, snum
  me.myspritenum = snum
  lastticks = the ticks
  stopanim = 0
  setstatusid(me, vlist)
  return me
end

on getstatus me
  return me.vlist
end

on setstatusid me, vlist
  if myuserinfolist <> vlist then
    myuserinfolist = duplicate(vlist)
    mycount = 1
    sprite(me.myspritenum - 1).member = gcharacter.getback(me.myuserinfolist.charid, me.myuserinfolist.connect)
    if vlist.connect then
      me.myemotionlist = gcharacter.getemotionlist(me.myuserinfolist.charid, me.myuserinfolist.emotionid)
      startanimation()
    else
      sprite(me.myspritenum).member = gcharacter.getemotionlist(me.myuserinfolist.charid, 0).pattern[1]
      stopanimation()
    end if
  end if
end

on exitFrame me
  if not stopanim then
    if the ticks - lastticks > myemotionlist.speed then
      lastticks = the ticks
      mycount = mycount + 1
      if mycount > myemotionlist.count(#pattern) then
        mycount = myemotionlist.loopstartnum
      end if
      tmpmember = myemotionlist.pattern[mycount]
      sprite(myspritenum).member = tmpmember
    end if
  end if
end

on stopanimation me
  stopanim = 1
end

on startanimation me
  stopanim = 0
end

on mouseEnter me
  stagewidth = the stageRight - the stageLeft
  centerh = stagewidth / 2
  myh = sprite(myspritenum).locH
  if myh + 277 < stagewidth then
    balloonposh = myh
  else
    if myh - 277 > 0 then
      balloonposh = myh - 277
    else
      balloonposh = centerh + myh - centerh / 2 - 138
    end if
  end if
  sendAllSprites(#popup, point(balloonposh, 55), myuserinfolist)
  cursor([member("cur1_1"), member("cur1_2")])
end

on mouseLeave me
  sendAllSprites(#deletepopup)
  cursor(-1)
end

on mouseUp me
  if the doubleClick then
    if equal(guser.getuserid(), me.myuserinfolist.userid) = 0 then
      gnewmessage.openWindow([me.myuserinfolist.userid], 0)
    end if
  end if
end

on deleteme me
  erase(member("name" & stringtonum(myuserinfolist.userid)))
  sprite(myspritenum).scriptInstanceList = []
  sprite(myspritenum).type = 0
  puppetSprite(myspritenum, 0)
  sprite(myspritenum - 1).type = 0
  puppetSprite(myspritenum - 1, 0)
  sprite(myspritenum + 1).type = 0
  puppetSprite(myspritenum + 1, 0)
  sendAllSprites(#deletemylist, myuserinfolist.userid)
  sendAllSprites(#resetcharapos)
end
