property imagename, func, isdown, myenabled, mycount

on beginSprite me
  sprite(me.spriteNum).memberNum = member(imagename).number
  myenabled = 1
end

on exitFrame me
  if me.myenabled and me.isdown and rollOver(me.spriteNum) then
    if me.mycount >= 1 then
      me.mycount = 0
      if func <> "" then
        do(func)
      end if
    else
      me.mycount = me.mycount + 1
    end if
  end if
end

on mouseEnter me
  if myenabled then
    if isdown then
      sprite(me.spriteNum).memberNum = member(imagename).number + 2
    else
      sprite(me.spriteNum).memberNum = member(imagename).number + 1
    end if
    cursor([member("cur1_1"), member("cur1_2")])
  end if
end

on mouseLeave me
  if myenabled then
    sprite(me.spriteNum).memberNum = member(imagename).number
  end if
  cursor(-1)
end

on mouseDown me
  if myenabled then
    if rollOver(me.spriteNum) then
      sprite(me.spriteNum).memberNum = member(imagename).number + 2
      isdown = 1
      if func <> "" then
        do(func)
      end if
      me.mycount = -3
    end if
  end if
end

on mouseUp me
  isdown = 0
  if me.myenabled then
    sprite(me.spriteNum).memberNum = member(imagename).number + 1
  else
    sprite(me.spriteNum).memberNum = member(imagename).number - 1
  end if
end

on mouseUpOutSide me
  isdown = 0
  if me.myenabled then
    sprite(me.spriteNum).memberNum = member(imagename).number
  else
    sprite(me.spriteNum).memberNum = member(imagename).number - 1
  end if
end

on enable me
  me.myenabled = 1
  if not isdown then
    sprite(me.spriteNum).memberNum = member(imagename).number
  end if
end

on disable me
  me.myenabled = 0
  if not isdown then
    sprite(me.spriteNum).memberNum = member(imagename).number - 1
  end if
end

on getPropertyDescriptionList me
  if the currentSpriteNum = 0 then
    memdefault = 0
  else
    memref = sprite(the currentSpriteNum).member
    castLibNum = memref.castLibNum
    memdefault = member(member(memref).memberNum, castLibNum)
  end if
  list = [:]
  addProp(list, #imagename, [#comment: "ボタンのイメージ:", #format: #graphic, #default: memdefault])
  addProp(list, #func, [#comment: "mouseUp時に呼び出す関数:", #format: #symbol, #default: ""])
  return list
end
