property fitwidth, fitheight, fitpos, fitpoint, mylocz

on beginSprite me
  stagewidth = the stageRight - the stageLeft
  stageheight = the stageBottom - the stageTop
  case fitpos of
    #左上:
      fitpoint = sprite(me.spriteNum).loc
    #右上:
      fitpoint = sprite(me.spriteNum).loc - point(stagewidth, 0)
    #左下:
      fitpoint = sprite(me.spriteNum).loc - point(0, stageheight)
    #右下:
      fitpoint = sprite(me.spriteNum).loc - point(stagewidth, stageheight)
  end case
  sprite(me.spriteNum).locZ = mylocz
end

on fitskin me
  stagewidth = the stageRight - the stageLeft
  stageheight = the stageBottom - the stageTop
  if fitwidth then
    sprite(me.spriteNum).width = stagewidth
  end if
  if fitheight then
    sprite(me.spriteNum).height = stageheight
  end if
  case fitpos of
    #左上:
      sprite(me.spriteNum).loc = point(0, 0) + fitpoint
    #右上:
      sprite(me.spriteNum).loc = point(stagewidth, 0) + fitpoint
    #左下:
      sprite(me.spriteNum).loc = point(0, stageheight) + fitpoint
    #右下:
      sprite(me.spriteNum).loc = point(stagewidth, stageheight) + fitpoint
  end case
end

on getPropertyDescriptionList me
  list = [:]
  addProp(list, #fitwidth, [#comment: "Widthをリサイズ:", #format: #boolean, #default: 0])
  addProp(list, #fitheight, [#comment: "Heightをリサイズ:", #format: #boolean, #default: 0])
  addProp(list, #fitpos, [#comment: "フィットする位置の原点:", #format: #symbol, #range: [#左上, #右上, #左下, #右下], #default: #左上])
  addProp(list, #mylocz, [#comment: "locZ:", #format: #integer, #default: 200000000])
  return list
end
