global gconnection, guserinfo, gnewmessage, gchatroom, guser

on prepareMovie
  setskin()
end

on setskin
  if not voidp(guser) then
    skin = guser.getskin()
    if castLib("skin").fileName <> skin then
      castLib("skin").fileName = skin
    end if
  end if
end

on setsprite snum, vink, vforecolor, vbackcolor, vMember, vloc, vvisible
  puppetSprite(snum, 1)
  sprite(snum).type = 1
  sprite(snum).ink = vink
  sprite(snum).forecolor = vforecolor
  sprite(snum).backcolor = vbackcolor
  sprite(snum).member = vMember
  sprite(snum).loc = vloc
  sprite(snum).visible = vvisible
end

on pushscrollleftbutton
  sendAllSprites(#scrollchara, 1)
end

on pushscrollrightbutton
  sendAllSprites(#scrollchara, -1)
end

on pushchatclosebutton
  close(the activeWindow)
end

on openWindow
  the itemDelimiter = ":"
  id = integer(item 3 of the title of the activeWindow)
  if objectp(gchatroom) then
    chattype = gchatroom.getchattype(id)
  end if
  if chattype <> #パブリック then
  end if
end

on closeWindow
  the itemDelimiter = ":"
  id = integer(item 3 of the title of the activeWindow)
  if objectp(gconnection) then
    gconnection.send("retire" && id)
  end if
  if objectp(gchatroom) then
    gchatroom.closeWindow(id)
  end if
  repeat with i = 1 to 1000
    puppetSprite(i, 0)
  end repeat
  go("closeFrame")
end

on resizeWindow
  sendAllSprites(#setminsize)
  sendAllSprites(#setmaxcharanum)
  sendAllSprites(#fitskin)
end

on zoomWindow
  sendAllSprites(#setminsize)
  sendAllSprites(#setmaxcharanum)
  sendAllSprites(#fitskin)
end

on activateWindow
  sendAllSprites(#activepopup)
end

on deactivateWindow
  sendAllSprites(#deactivepopup)
end
