property pmyfolderlist, pmyspritenum, pisselected, pbeforetextpos, pisdrag, pmyenabled

on new me, vlist, snum
  me.pmyfolderlist = vlist
  me.pmyspritenum = snum
  me.pisselected = 0
  me.pisdrag = 0
  me.pmyenabled = 1
  return me
end

on setfolderlist me, vlist
  me.pmyfolderlist = vlist
end

on mouseDown me
  if pmyenabled then
    sendAllSprites(#notselecttab)
    selecttab(me)
  end if
end

on selecttab me
  me.pisselected = 1
  sprite(me.pmyspritenum).member = "TabSelected"
  sendAllSprites(#setnowfolder, me.pmyfolderlist)
end

on notselecttab me
  me.pisselected = 0
  sprite(me.pmyspritenum).member = "TabNotSelected"
end

on mouseEnter me
  if pmyenabled then
    if not me.pisselected then
      if me.pisdrag then
        sendAllSprites(#deleteibeam)
        sprite(me.pmyspritenum).member = "TabDAD"
      else
        sprite(me.pmyspritenum).member = "TabOver"
        cursor([member("cur1_1"), member("cur1_2")])
      end if
    end if
  end if
end

on mouseLeave me
  if pmyenabled then
    if not me.pisselected then
      if me.pisdrag then
        sendAllSprites(#showibeam)
        sprite(me.pmyspritenum).member = "TabNotSelected"
      else
        sprite(me.pmyspritenum).member = "TabNotSelected"
        cursor(-1)
      end if
    end if
  end if
end

on mouseUp me
  if pmyenabled then
    if not me.pisselected then
      sprite(me.pmyspritenum).member = "TabNotSelected"
      sendAllSprites(#dragmytab, me.pmyfolderlist.folderid)
      sendAllSprites(#showibeam)
      me.pisdrag = 0
    end if
  end if
end

on dragstart me
  me.pisdrag = 1
end

on dragstop me
  me.pisdrag = 0
end

on enable me
  me.pmyenabled = 1
end

on disable me
  me.pmyenabled = 0
end
