property isdown, dis, limitdir, limitmin, limitmax, lcolor, linksnum, linksdis

on beginSprite me
  sprite(me.spriteNum).locZ = 200000000
  isdown = 0
  linksdis = sprite(me.spriteNum).loc - sprite(me.spriteNum + linksnum).loc
end

on mouseDown me
  isdown = 1
  dis = sprite(me.spriteNum).loc - point(the mouseH, the mouseV)
end

on mouseUp me
  isdown = 0
end

on mouseUpOutSide me
  isdown = 0
end

on exitFrame me
  if isdown then
    sprite(me.spriteNum).loc = point(the mouseH, the mouseV) + dis
    case limitdir of
      #h方向を制限:
        if sprite(me.spriteNum).locH < limitmin then
          sprite(me.spriteNum).locH = limitmin
        else
          if sprite(me.spriteNum).locH > limitmax then
            sprite(me.spriteNum).locH = limitmax
          end if
        end if
      #v方向を制限:
        if sprite(me.spriteNum).locV < limitmin then
          sprite(me.spriteNum).locV = limitmin
        else
          if sprite(me.spriteNum).locV > limitmax then
            sprite(me.spriteNum).locV = limitmax
          end if
        end if
      #なし:
        nothing()
    end case
    case lcolor of
      #赤:
        sprite(me.spriteNum).locH = 131
      #黄色:
        sprite(me.spriteNum).locV = abs(sprite(me.spriteNum).locH - 230) * 23 / 40 + 58
      #青:
        sprite(me.spriteNum).locV = sprite(me.spriteNum).locH * 23 / 40 + 39
    end case
    sprite(me.spriteNum + linksnum).loc = sprite(me.spriteNum).loc - linksdis
    repeat with i = 1 to 5
      sendSprite(i + 4, #movevertex, sprite(i + 10).loc, sprite(i + 11).loc)
    end repeat
    sendSprite(10, #movevertex, sprite(16).loc, sprite(11).loc)
  end if
end

on getPropertyDescriptionList me
  list = [:]
  addProp(list, #limitdir, [#comment: "方向の制限:", #format: #symbol, #range: [#なし, #h方向を制限, #v方向を制限], #default: #なし])
  addProp(list, #lcolor, [#comment: "何色？:", #format: #symbol, #range: [#なし, #赤, #黄色, #青], #default: #なし])
  addProp(list, #linksnum, [#comment: "関連付け:", #format: #integer, #default: 0])
  addProp(list, #limitmin, [#comment: "最小値:", #format: #integer, #default: 0])
  addProp(list, #limitmax, [#comment: "最大値:", #format: #integer, #default: 0])
  return list
end
