property muserid, mspritenum, misselected, mindex, menabled

on new me, index, userid, spriteNum, h, v
  me.mindex = index
  me.muserid = userid
  me.mspritenum = spriteNum
  sprite(me.mspritenum).type = 1
  sprite(me.mspritenum).puppet = 1
  sprite(me.mspritenum).member = "label" & userid
  sprite(me.mspritenum).loc = point(h, v)
  sprite(me.mspritenum).scriptInstanceList.add(me)
  me.menabled = 1
  return me
end

on clear me
  sprite(me.mspritenum).scriptInstanceList = []
  sprite(me.mspritenum).puppet = 0
  sprite(me.mspritenum).type = 0
end

on mouseEnter me
  if me.menabled then
    if not me.misselected then
      sprite(me.mspritenum).member.forecolor = 0
      sprite(me.mspritenum).member.backcolor = 245
    end if
  end if
end

on mouseLeave me
  if not me.misselected then
    sprite(me.mspritenum).member.forecolor = 255
    sprite(me.mspritenum).member.backcolor = 245
  end if
end

on mouseDown me
  me.misselected = 1
  sprite(me.mspritenum).member.forecolor = 0
  sprite(me.mspritenum).member.backcolor = 7
  sendAllSprites(#_select, me.mindex)
  sendAllSprites(#select, me.mindex)
  sendSprite(10, #enable)
end

on _select me, index
  if index <> me.mindex then
    me.misselected = 0
    if sprite(me.mspritenum).member.forecolor <> 255 then
      sprite(me.mspritenum).member.forecolor = 255
    end if
    if sprite(me.mspritenum).member.backcolor <> 245 then
      sprite(me.mspritenum).member.backcolor = 245
    end if
  else
    me.misselected = 1
  end if
end

on listenable me
  me.menabled = 1
end

on listdisable me
  me.menabled = 0
end
