property mresult, mspritenum, misselected, mindex, menabled
global gcharacter, gconnection

on new me, index, msg, spriteNum, h, v
  me.mindex = index
  me.mresult = msg
  me.mspritenum = spriteNum
  sprite(me.mspritenum).type = 1
  sprite(me.mspritenum).puppet = 1
  sprite(me.mspritenum).ink = 0
  sprite(me.mspritenum).member = "label" & stringtonum(msg.userid)
  sprite(me.mspritenum).loc = point(h, v)
  sprite(me.mspritenum).scriptInstanceList.add(me)
  sprite(me.mspritenum + 1).type = 1
  sprite(me.mspritenum + 1).puppet = 1
  sprite(me.mspritenum + 1).ink = 36
  sprite(me.mspritenum + 1).forecolor = 255
  sprite(me.mspritenum + 1).backcolor = 2
  if msg.connect then
    sprite(me.mspritenum + 1).member = gcharacter.getcharacterlist(msg.charid, 0).smallimages[2]
  else
    sprite(me.mspritenum + 1).member = gcharacter.getcharacterlist(msg.charid, 0).smallimages[1]
  end if
  sprite(me.mspritenum + 1).loc = point(h - 16, v + 8)
  me.menabled = 1
  return me
end

on clearresult me
  sprite(me.mspritenum).scriptInstanceList = []
  sprite(me.mspritenum).puppet = 0
  sprite(me.mspritenum).type = 0
  sprite(me.mspritenum + 1).puppet = 0
  sprite(me.mspritenum + 1).type = 0
end

on mouseEnter me
  if me.menabled then
    if not me.misselected then
      sprite(me.mspritenum).member.forecolor = 0
      sprite(me.mspritenum).member.backcolor = 245
    end if
  end if
end

on mouseLeave me
  if not me.misselected then
    sprite(me.mspritenum).member.forecolor = 255
    sprite(me.mspritenum).member.backcolor = 245
  end if
end

on mouseUp me
  if the doubleClick then
    if objectp(gconnection) then
      gconnection.send("info" && me.mresult.userid)
    end if
  end if
end

on mouseDown me
  me.misselected = 1
  sprite(me.mspritenum).member.forecolor = 0
  sprite(me.mspritenum).member.backcolor = 7
  sendAllSprites(#_selectresult, me.mindex)
  sendAllSprites(#selectresult, me.mindex)
end

on _selectresult me, index
  if index <> me.mindex then
    me.misselected = 0
    if sprite(me.mspritenum).member.forecolor <> 255 then
      sprite(me.mspritenum).member.forecolor = 255
    end if
    if sprite(me.mspritenum).member.backcolor <> 245 then
      sprite(me.mspritenum).member.backcolor = 245
    end if
  else
    me.misselected = 1
  end if
end

on listenable me
  me.menabled = 1
end

on listdisable me
  me.menabled = 0
end
