property mpos, mtickcount, mdelay, mflag, mstr

on beginSprite me
  sprite(me.spriteNum).member.forecolor = 255
  sprite(me.spriteNum).member.backcolor = 11
  sprite(me.spriteNum).locZ = 2000
  me.hidehint()
end

on endSprite me
  me.hidehint()
  sprite(me.spriteNum).locZ = me.spriteNum
end

on exitFrame me
  if me.mflag then
    if the ticks >= me.mtickcount + me.mdelay then
      sprite(me.spriteNum).member.text = mstr
      rect = sprite(me.spriteNum).member.rect
      rect.right = 6 * me.length(mstr) + 2
      sprite(me.spriteNum).member.rect = rect
      height = sprite(me.spriteNum).member.rect.bottom
      if the mouseV + 16 + height > the stageBottom - the stageTop then
        sprite(me.spriteNum).loc = point(the mouseH, the mouseV - 16 - height)
      else
        sprite(me.spriteNum).loc = point(the mouseH, the mouseV + 16)
      end if
      me.mflag = 0
    end if
  end if
end

on showhint me, str, x, y, delay
  me.mflag = 1
  me.mtickcount = the ticks
  me.mdelay = delay
  me.mstr = str
end

on length me, str
  cnt = 0
  repeat with i = 1 to str.length
    if charToNum(char i of str) > 255 then
      cnt = cnt + 2
    else
      cnt = cnt + 1
    end if
  end repeat
  return cnt
end

on hidehint me
  sprite(me.spriteNum).loc = point(-1000, -1000)
  sprite(me.spriteNum).member.text = ""
  me.mflag = 0
end
