property mroomid, mmember, mwindow, mchattype, misjoined, mwindowname, mproplist
global guser, gconnection, gdebug, gskinname

on new me, chattype, msg, msg2
  me.mchattype = chattype
  me.mroomid = msg.roomid
  me.mmember = []
  me.mproplist = []
  me.mwindow = window("chat" & me.mroomid)
  me.mwindow.fileName = the moviePath & "data¥chat.dir"
  me.mwindow.windowType = 0
  me.mwindow.rect = offsetrect(me.mwindow.rect)
  me.mwindow.visible = 1
  me.mwindowname = me.mwindow.name
  case me.mchattype of
    #自分から:
      if objectp(guser) then
        if guser.getsound() then
          puppetSound(2, "newMesseage")
        end if
      end if
      me.mwindow.title = "プライベートチャット" && the date && the time && "ID:" & me.mroomid
      me.misjoined = 0
      tell mwindow
        sendAllSprites(#addstring, "*** 「" & msg.status.userid & "」さんから返事が届きました。 ***", [#color: 8, #fontSize: 12])
        sendAllSprites(#sendmsg, msg2)
        sendAllSprites(#setstatus, msg.status)
        sendAllSprites(#showguestbutton)
      end tell
      if minimum() then
        tmpstr = "「" & msg.status.userid & "」さんから返事が届きました。"
        alert(tmpstr)
      end if
    #他人から:
      if objectp(guser) then
        if guser.getsound() then
          puppetSound(2, "newMesseage")
        end if
      end if
      me.mwindow.title = "プライベートチャット" && the date && the time && "ID:" & me.mroomid
      me.misjoined = 0
      gconnection.send("member" && me.mroomid)
      tell me.mwindow
        sendAllSprites(#addstring, "*** 「" & msg.userid & "」さんからチャットのおさそいです。 ***", [#color: 8, #fontSize: 12])
        sendAllSprites(#receivemsg, msg)
        sendAllSprites(#showguestbutton)
      end tell
      if minimum() then
        tmpstr = "「" & msg.userid & "」さんからチャットのおさそいです。"
        alert(tmpstr)
      end if
    #パブリック:
      me.mwindow.title = "パブリックチャット「" && msg2 && "」" && the date && the time && "ID:" & me.mroomid
      me.misjoined = 1
      gconnection.send("member" && me.mroomid)
      tell me.mwindow
        sendAllSprites(#addstring, "*** ここは「" && msg2 && "」です。 ***", [#color: 8, #fontSize: 12])
      end tell
  end case
  return me
end

on getroomid me
  return me.mroomid
end

on getchattype me
  return me.mchattype
end

on receivestatus me, msg
  pos = me.searchmember(msg.userid)
  if pos then
    me.mmember[pos] = msg
  else
    me.mmember.add(msg)
    if equal(msg.userid, guser.getuserid()) then
      me.mproplist.add([#color: 6, #fontSize: 12])
    else
      me.mproplist.add([#color: 255, #fontSize: 12])
    end if
  end if
  tell me.mwindow
    sendAllSprites(#setstatus, msg)
  end tell
end

on addstatus me, msg
  pos = me.searchmember(msg.userid)
  if pos then
    me.mmember[pos] = msg
  else
    me.mmember.add(msg)
    if equal(msg.userid, guser.getuserid()) then
      me.mproplist.add([#color: 6, #fontSize: 12])
    else
      me.mproplist.add([#color: 255, #fontSize: 12])
    end if
  end if
  if equal(guser.getuserid(), msg.userid) = 0 then
    tell me.mwindow
      sendAllSprites(#setstatus, msg)
    end tell
  else
    if me.misjoined then
      tell me.mwindow
        sendAllSprites(#setstatus, msg)
      end tell
    end if
  end if
end

on searchmember me, userid
  pos = 0
  repeat with i = 1 to me.count(#mmember)
    member = me.mmember[i]
    if equal(userid, member.userid) then
      pos = i
    else
    end if
  end repeat
  return pos
end

on _receivemsg me, msg
  if me.mchattype = #自分から and not me.misjoined then
    me.misjoined = 1
    gconnection.send("member" && me.mroomid)
  end if
  tell mwindow
    sendAllSprites(#receivemsg, msg)
  end tell
end

on receiveretired me, msg
  pos = me.searchmember(msg.userid)
  if pos then
    me.mmember.deleteAt(pos)
    me.mproplist.deleteAt(pos)
    tell mwindow
      sendAllSprites(#receiveretired, msg)
      sendAllSprites(#retire, msg)
    end tell
  end if
end

on sendmsg me, msg
  if not me.misjoined then
    me.misjoined = 1
    gconnection.send("member" && me.mroomid)
  end if
  tell mwindow
    sendAllSprites(#sendmsg, msg)
  end tell
end

on receivejoined me, msg
  me.mmember.add(msg.status)
  if equal(msg.status.userid, guser.getuserid()) then
    me.mproplist.add([#color: 6, #fontSize: 12])
  else
    me.mproplist.add([#color: 255, #fontSize: 12])
  end if
  tell mwindow
    sendAllSprites(#setstatus, msg.status)
    sendAllSprites(#receivejoined, msg)
  end tell
end

on setskin me
  if objectp(guser) then
    tell mwindow
      skin = guser.getskin()
      if castLib("skin").fileName <> skin then
        castLib("skin").fileName = skin
      end if
    end tell
  end if
end

on _getprop me, userid
  pos = me.searchmember(userid)
  if pos then
    return me.mproplist[pos]
  end if
end
