property mupimage, mdownimage, mrolloverimage, mdisableimage, menabled, mtracking

on beginSprite me
  me.mupimage = sprite(me.spriteNum).member
  me.mtracking = 0
  if not me.menabled then
    sprite(me.spriteNum).member = me.mdisableimage
  end if
end

on endSprite me
  cursor(-1)
end

on mouseDown me
  if me.menabled then
    sprite(me.spriteNum).member = me.mdownimage
    me.mtracking = 1
  else
    dontPassEvent()
  end if
end

on mouseUp me
  if me.menabled then
    if me.mtracking then
      sprite(me.spriteNum).member = me.mrolloverimage
      updateStage()
    end if
    me.mtracking = 0
  else
    dontPassEvent()
  end if
end

on mouseEnter me
  if me.menabled then
    cursor([member("cur1_1"), member("cur1_2")])
    if me.mtracking then
      sprite(me.spriteNum).member = me.mdownimage
    else
      sprite(me.spriteNum).member = me.mrolloverimage
    end if
  else
    dontPassEvent()
  end if
end

on mouseLeave me
  if me.menabled then
    cursor(-1)
    sprite(me.spriteNum).member = me.mupimage
  else
    dontPassEvent()
  end if
end

on mouseUpOutSide me
  if me.menabled then
    cursor(-1)
    me.mtracking = 0
  else
    dontPassEvent()
  end if
end

on enable me
  me.menabled = 1
  sprite(me.spriteNum).member = me.mupimage
end

on disable me
  me.menabled = 0
  sprite(me.spriteNum).member = me.mdisableimage
end

on getPropertyDescriptionList
  memnum = sprite(the currentSpriteNum).member.memberNum
  cstnum = sprite(the currentSpriteNum).member.castLibNum
  plist = [#mrolloverimage: [#comment: "ロールオーバーのイメージ:", #format: #graphic, #default: member(memnum + 1, cstnum)], #mdownimage: [#comment: "押した状態のイメージ:", #format: #graphic, #default: member(memnum + 2, cstnum)], #mdisableimage: [#comment: "不可状態のイメージ", #format: #graphic, #default: member(memnum + 3, cstnum)], #menabled: [#comment: "初期状態", #format: #boolean, #default: 1]]
  return plist
end
