global gchatroom, guser

on beginSprite me
  sprite(me.spriteNum).member.text = ""
  sprite(me.spriteNum).member.forecolor = 255
  sprite(me.spriteNum).member.backcolor = 0
  sprite(me.spriteNum).member.fontSize = 12
  sprite(me.spriteNum).member.scrollTop = 0
end

on sendmsg me, msg
  str = string(msg.userid) && ":" && string(msg.msg)
  the itemDelimiter = ":"
  id = integer(item 3 of the title of the activeWindow)
  plist = gchatroom._getprop(id, msg.userid)
  if voidp(plist) then
    me.addstring(str, [#color: 6, #fontSize: 12])
  else
    if me._setprop(plist, msg.msg) = 0 then
      me.addstring(str, plist)
    end if
  end if
end

on receivemsg me, msg
  str = string(msg.userid) && ":" && string(msg.msg)
  the itemDelimiter = ":"
  id = integer(item 3 of the title of the activeWindow)
  plist = gchatroom._getprop(id, msg.userid)
  if voidp(plist) then
    me.addstring(str)
  else
    if me._setprop(plist, msg.msg) = 0 then
      me.addstring(str, plist)
    end if
  end if
end

on receivejoined me, msg
  str = "*** 「" && string(msg.status.userid) && "」さんが入室しました。 ***"
  me.addstring(str, [#color: 8, #fontSize: 12])
end

on receiveretired me, msg
  str = "*** 「" && string(msg.userid) && "」さんが退室しました。 ***"
  me.addstring(str, [#color: 8, #fontSize: 12])
end

on addstring me, msg, plist
  lastlines = the number of lines in the text of the member of sprite(the spriteNum of me)
  str = msg & RETURN
  -- unk21
  ERROR.setContentsAfter(ERROR)
  curlines = the number of lines in the text of the member of sprite(the spriteNum of me)
  sprite(me.spriteNum).member.scrollByLine(curlines - lastlines)
  if not voidp(plist) then
    -- ERROR: Unknown property type 10
    -- ERROR: Unknown property type 10
  else
    -- ERROR: Unknown property type 10
    -- ERROR: Unknown property type 10
  end if
end

on save me
  path = filesaveasdialog(the moviePath & "..¥", "名称未設定.txt", "ログの書き出し", 1)
  if path <> "" then
    file = new(xtra("fileio"))
    if objectp(file) then
      if fileexists(path) = 0 then
        deletefile(path)
      end if
      createfile(file, path)
      openfile(file, path, 2)
      writestring(file, sprite(me.spriteNum).member.text)
      closefile(file)
    end if
    file = 0
  end if
end

on _setprop me, plist, str
  the itemDelimiter = "="
  if offset("#color=", str) then
    tmp = value(item 2 of str)
    if tmp then
      plist.setProp(#color, tmp)
      return 1
    end if
  else
    if offset("#size=", str) then
      tmp = value(item 2 of str)
      if tmp then
        plist.setProp(#fontSize, tmp)
        return 1
      end if
    else
      if offset("#bell=", str) then
        if objectp(guser) then
          tmp = item 2 of str
          if equal(tmp, guser.getuserid()) then
            beep()
          end if
        end if
        return 1
      end if
    end if
  end if
  return 0
end
