property pfriendlist, pfolderlist, pviewmode, phexlist, pfirstcharasnum, pfirstcharaloc, pfirstfolderloc, pnextcharapos, ptextoffset, pnextfolderwidth, pselectlist, pnowfolderlist, pscrollnum, ptabscrollnum, pminwidth, pminheight, pbeforewidth
global gcharacter, gfriendlist, matsudebugmode, gconnection

on beginSprite me
  setviewmode(me, #big)
  me.pfirstcharasnum = 50
  me.pfirstfolderloc = point(19, 11)
  me.pnextfolderwidth = 97
  me.pfolderlist = []
  me.pfriendlist = []
  me.pselectlist = []
  me.pnowfolderlist = [:]
  me.pscrollnum = 0
  me.ptabscrollnum = 0
  me.pminwidth = the stageRight - the stageLeft
  me.pminheight = the stageBottom - the stageTop
  me.pbeforewidth = me.pminwidth
  if objectp(gfriendlist) then
    repeat with i = 1 to gfriendlist.count(#mfriendlist)
      setfolder(me, [#folderid: gfriendlist.mfriendlist[i].folderid, #name: gfriendlist.mfriendlist[i].name])
    end repeat
    if gfriendlist.count(#mfriendlist) then
      sendmessagetomain("folder show" && gfriendlist.mfriendlist[1].folderid)
    end if
  end if
end

on exitFrame me
  go(the frame)
end

on setfolder me, vlist
  testnum = 0
  repeat with i = 1 to me.count(#pfolderlist)
    if me.pfolderlist[i].folderid = vlist.folderid then
      testnum = i
    else
    end if
  end repeat
  if testnum = 0 then
    tmp = 0
    repeat while 1
      tmpsnum = me.pfirstcharasnum + tmp
      if sprite(tmpsnum).type = 0 and sprite(tmpsnum + 1).type = 0 then
        newsnum = tmpsnum
        exit repeat
      else
        tmp = tmp + 1
      end if
    end repeat
    me.pfolderlist.add([#folderid: vlist.folderid, #folderName: vlist.name, #snum: newsnum])
    newcount = me.count(#pfolderlist) - 1
    newloc = searchtabloc(me, newcount)
    setsprite(newsnum, 36, 255, 0, "TabNotSelected", newloc, 1)
    add(sprite(newsnum).scriptInstanceList, new(script("ToFrontTab"), newsnum))
    add(sprite(newsnum).scriptInstanceList, new(script("フォルダー選択"), vlist, newsnum))
    newmember = new(#field)
    member(newmember).name = "folderName" & vlist.folderid
    rect = member(newmember).rect
    rect.right = me.pnextfolderwidth
    member(newmember).rect = rect
    member(newmember).alignment = "center"
    member(newmember).text = vlist.name & " "
    setsprite(newsnum + 1, 36, 255, 0, member(newmember).name, newloc + point(0, 5), 1)
    add(sprite(newsnum + 1).scriptInstanceList, new(script("ToFrontTab"), newsnum + 1))
    if me.count(#pnowfolderlist) = 0 then
      me.pnowfolderlist = vlist
      sendAllSprites(#selectfirsttab)
    end if
  else
    repeat with i = 1 to me.count(#pfolderlist)
      if me.pfolderlist[i].folderid = vlist.folderid then
        member(sprite(me.pfolderlist[i].snum + 1).member).text = vlist.name & " "
        tmplist = [#folderid: vlist.folderid, #folderName: vlist.name, #snum: me.pfolderlist[i].snum]
        tmplist2 = [#folderid: vlist.folderid, #name: vlist.name]
        me.pfolderlist[i] = tmplist
        me.pnowfolderlist = tmplist2
        sendSprite(me.pfolderlist[i].snum, #setfolderlist, tmplist2)
      end if
    end repeat
  end if
end

on deletefolder me, vlist
  deletenum = 0
  repeat with i = 1 to me.count(#pfolderlist)
    if me.pfolderlist[i].folderid = vlist.folderid then
      deletesnum = me.pfolderlist[i].snum
      sprite(deletesnum).scriptInstanceList = []
      sprite(deletesnum).locZ = deletesnum
      sprite(deletesnum).type = 0
      puppetSprite(deletesnum, 0)
      sprite(deletesnum + 1).scriptInstanceList = []
      sprite(deletesnum + 1).locZ = deletesnum + 1
      sprite(deletesnum + 1).type = 0
      puppetSprite(deletesnum + 1, 0)
      deleteAt(me.pfolderlist, i)
      me.pnowfolderlist = []
      repeat with i = 1 to me.count(#pfolderlist)
        setloc = searchtabloc(me, i - 1)
        sprite(me.pfolderlist[i].snum).loc = setloc
        sprite(me.pfolderlist[i].snum + 1).loc = setloc + point(0, 5)
      end repeat
      sendAllSprites(#selectfirsttab)
    else
    end if
  end repeat
end

on setstatus me, vlist
  if vlist.folderid = me.pnowfolderlist.folderid then
    testnum = 0
    repeat with i = 1 to me.count(#pfriendlist)
      if equal(me.pfriendlist[i].userid, vlist.userid) then
        testnum = i
      else
      end if
    end repeat
    if testnum = 0 then
      tmp = 0
      repeat while 1
        tmpsnum = me.pfirstcharasnum + 100 + tmp
        if sprite(tmpsnum).type = 0 and sprite(tmpsnum + 1).type = 0 and sprite(tmpsnum + 2).type = 0 then
          newsnum = tmpsnum
          exit repeat
        else
          tmp = tmp + 1
        end if
      end repeat
      add(me.pfriendlist, [#userid: vlist.userid, #snum: newsnum])
      newcount = me.count(#pfriendlist) - 1
      newloc = searchmyloc(me, newcount, getmaxcount(me).h)
      case me.pviewmode of
        #big:
          setsprite(newsnum, 0, 255, 0, "dummy", newloc, 1)
        #small:
          setsprite(newsnum, 0, 255, 0, "dummy", newloc, 1)
      end case
      sprite(newsnum).locZ = newsnum
      case me.pviewmode of
        #big:
          setsprite(newsnum + 1, 36, 255, 40, "dummy", newloc, 0)
        #small:
          setsprite(newsnum + 1, 36, 255, 40, "dummy", newloc, 0)
      end case
      sprite(newsnum + 1).locZ = newsnum + 1
      add(sprite(newsnum + 1).scriptInstanceList, new(script("キャラ表示"), vlist, newsnum + 1))
      add(sprite(newsnum + 1).scriptInstanceList, new(script("出現消失"), vlist, newsnum + 1))
      sendSprite(newsnum + 1, #setmyviewmode, me.pviewmode)
      newmember = new(#field)
      member(newmember).name = "name" & stringtonum(vlist.userid)
      rect = member(newmember).rect
      rect.right = 86
      member(newmember).rect = rect
      case me.pviewmode of
        #big:
          member(newmember).alignment = "center"
        #small:
          member(newmember).alignment = "left"
      end case
      member(newmember).font = "ＭＳ ゴシック"
      member(newmember).fontSize = 12
      member(newmember).text = vlist.userid & " "
      setsprite(newsnum + 2, 36, 255, 0, member(newmember).name, newloc + me.ptextoffset, 1)
      sprite(newsnum + 2).locZ = newsnum + 2
      add(sprite(newsnum + 2).scriptInstanceList, new(script("文字用ビヘ"), newsnum + 2))
      resize(me)
    else
      testsnum = me.pfriendlist[testnum].snum
      sendSprite(testsnum + 1, #setstatusid, vlist)
    end if
  end if
end

on deletestatus me, vlist
  deletenum = 0
  repeat with i = 1 to me.count(#pfriendlist)
    if equal(me.pfriendlist[i].userid, vlist.userid) then
      deletesnum = me.pfriendlist[i].snum + 1
      sendSprite(deletesnum, #deleteme)
    else
    end if
  end repeat
end

on renumfriend me, vlist
  tmplist = []
  repeat with i = 1 to vlist.count(#member)
    repeat with j = 1 to me.count(#pfriendlist)
      if equal(me.pfriendlist[j].userid, vlist.member[i]) then
        add(tmplist, me.pfriendlist[j])
      else
      end if
    end repeat
  end repeat
  me.pfriendlist = duplicate(tmplist)
  resize(me)
end

on searchmyloc me, vcount, vmaxcount
  newloc = me.pfirstcharaloc + vcount / vmaxcount + me.pscrollnum * point(0, me.pnextcharapos[2]) + vcount mod vmaxcount * point(me.pnextcharapos[1], 0)
  return newloc
end

on searchtabloc me, vcount
  return pfirstfolderloc + point(vcount + me.ptabscrollnum * me.pnextfolderwidth, 0)
end

on getmaxcount me
  case me.pviewmode of
    #big:
      maxhcount = the stageRight - the stageLeft - 136 / 80 + 1
      maxvcount = the stageBottom - the stageTop - 160 / 80 + 1
    #small:
      maxhcount = the stageRight - the stageLeft - 170 / 120 + 1
      maxvcount = the stageBottom - the stageTop - 103 / 22 + 1
  end case
  return [#h: maxhcount, #v: maxvcount]
end

on setviewmode me, vmode
  me.pviewmode = vmode
  case vmode of
    #big:
      me.pfirstcharaloc = point(58, 70)
      me.pnextcharapos = point(80, 80)
      me.ptextoffset = point(-43, 26)
    #small:
      me.pfirstcharaloc = point(32, 44)
      me.pnextcharapos = point(120, 22)
      me.ptextoffset = point(10, -4)
  end case
end

on getviewmode me
  return me.pviewmode
end

on changeviewmode me
  if me.pselectlist <> [] then
    sendSprite(me.pselectlist.snum, #deleteselectmask)
  end if
  the updateLock = 1
  case me.pviewmode of
    #big:
      setviewmode(me, #small)
      sendAllSprites(#setmyviewmode, me.pviewmode)
      resize(me)
      repeat with i = 1 to me.count(#pfriendlist)
        sprite(me.pfriendlist[i].snum + 2).member.alignment = "left"
      end repeat
    #small:
      setviewmode(me, #big)
      repeat with i = 1 to me.count(#pfriendlist)
        sprite(me.pfriendlist[i].snum + 2).member.alignment = "center"
      end repeat
      resize(me)
      sendAllSprites(#setmyviewmode, me.pviewmode)
  end case
  the updateLock = 0
end

on getfirstcharasnum me
  return me.pfirstcharasnum
end

on gethexlist me
  return me.phexlist
end

on setselectlist me, vlist
  me.pselectlist = vlist
end

on deleteselectlist me
  me.pselectlist = []
end

on deleteselectfriend me
  fid = sendAllSprites(#getfoldern).folderid
  if me.pselectlist <> [] then
    sendstring = "friend rmv" && fid && me.pselectlist.userid
    if not matsudebugmode then
      sendmessagetomain(sendstring)
      sendAllSprites(#startwaiting)
    end if
    me.pselectlist = []
  end if
end

on movefriendlist me, vnum
  tmplist = []
  beforepos = 0
  repeat with i = 1 to me.count(#pfriendlist)
    if equal(me.pfriendlist[i].userid, me.pselectlist.userid) then
      tmplist = me.pfriendlist[i]
      beforepos = i
    else
    end if
  end repeat
  if tmplist <> [] then
    if vnum > me.count(#pfriendlist) then
      deleteAt(me.pfriendlist, beforepos)
      add(me.pfriendlist, tmplist)
    else
      if beforepos > vnum then
        deleteAt(me.pfriendlist, beforepos)
        addAt(me.pfriendlist, vnum, tmplist)
      else
        if beforepos < vnum then
          addAt(me.pfriendlist, vnum, tmplist)
          deleteAt(me.pfriendlist, beforepos)
        end if
      end if
    end if
  end if
  if beforepos <> vnum and beforepos + 1 <> vnum then
    sendstring = "friend renum" && me.pnowfolderlist.folderid
    repeat with i = 1 to me.count(#pfriendlist)
      sendstring = sendstring && me.pfriendlist[i].userid
    end repeat
    if not matsudebugmode then
      sendmessagetomain(sendstring)
      sendAllSprites(#startwaiting)
    end if
  end if
end

on slidechara me, vnum
  repeat with i = 1 to me.count(#pfriendlist)
    if me.pfriendlist[i].snum = vnum then
      erase(member("name" & stringtonum(me.pfriendlist[i].userid)))
      deleteAt(me.pfriendlist, i)
    else
    end if
  end repeat
  resize(me)
end

on setnowfolder me, vlist
  if me.pselectlist <> [] then
    sendSprite(me.pselectlist.snum, #deleteselectmask)
  end if
  if me.pnowfolderlist = [] then
    deletenowfolderinfo(me)
    me.pnowfolderlist = vlist
    sendmessagetomain("folder show" && me.pnowfolderlist.folderid)
    sendAllSprites(#startwaiting)
    me.pscrollnum = 0
  else
    if me.pnowfolderlist.folderid <> vlist.folderid then
      tmpfolderid = me.pnowfolderlist.folderid
      deletenowfolderinfo(me)
      me.pnowfolderlist = vlist
      sendmessagetomain("folder hide" && tmpfolderid)
      sendmessagetomain("folder show" && me.pnowfolderlist.folderid)
      sendAllSprites(#startwaiting)
      me.pscrollnum = 0
    end if
  end if
  updateStage()
  gfriendlist.updatefolder(me.pnowfolderlist.folderid)
end

on deletefriendinfo me, vnum
  erase(member("name" & stringtonum(me.pfriendlist[vnum].userid)))
  sendSprite(me.pfriendlist[vnum].snum, #deleteselectmask)
  sprite(me.pfriendlist[vnum].snum + 1).scriptInstanceList = []
  sprite(me.pfriendlist[vnum].snum + 0).type = 0
  sprite(me.pfriendlist[vnum].snum + 1).type = 0
  sprite(me.pfriendlist[vnum].snum + 2).scriptInstanceList = []
  sprite(me.pfriendlist[vnum].snum + 2).type = 0
  puppetSprite(sprite(me.pfriendlist[vnum].snum + 0), 0)
  puppetSprite(sprite(me.pfriendlist[vnum].snum + 1), 0)
  puppetSprite(sprite(me.pfriendlist[vnum].snum + 2), 0)
  deleteAt(me.pfriendlist, vnum)
  resize(me)
end

on deletenowfolderinfo me
  repeat with i = me.count(#pfriendlist) down to 1
    deletefriendinfo(me, i)
  end repeat
  me.pfriendlist = []
  me.pselectlist = []
  me.pnowfolderlist = []
end

on getfoldern me
  return me.pnowfolderlist
end

on getfriendlist me
  return me.pfriendlist
end

on getfolderlist me
  return me.pfolderlist
end

on getselectlist me
  return me.pselectlist
end

on getselectcharaid me
  re = -1
  if me.pselectlist <> [] then
    re = me.pselectlist.userid
  end if
  return re
end

on dragmytab me, vnum
  if me.pselectlist <> [] then
    sendstring = "friend move" && me.pnowfolderlist.folderid && vnum
    sendstring = sendstring && me.pselectlist.userid
    sendmessagetomain(sendstring)
    sendAllSprites(#startwaiting)
    result = 0
    repeat with j = 1 to me.count(#pfriendlist)
      if equal(me.pfriendlist[j].userid, me.pselectlist.userid) then
        result = j
        sendSprite(me.pselectlist.snum, #deleteselectmask)
      else
      end if
    end repeat
    if result <> 0 then
      deletefriendinfo(me, result)
    end if
    me.pselectlist = []
  end if
end

on selectfirsttab me
  sendSprite(me.pfolderlist[1].snum, #selecttab)
end

on getmycount me, snum
  re = 0
  repeat with i = 1 to me.count(#pfriendlist)
    if snum - 1 = me.pfriendlist[i].snum then
      re = i
    else
    end if
  end repeat
  return re
end

on resize me
  if the stageRight - the stageLeft > me.pbeforewidth then
    me.pscrollnum = 0
  end if
  me.pbeforewidth = the stageRight - the stageLeft
  maxhcount = getmaxcount(me).h
  maxvcount = getmaxcount(me).v
  maxcharanum = maxhcount * maxvcount
  vcount = me.count(#pfriendlist) / maxhcount + 1
  repeat with i = 1 to me.count(#pfriendlist)
    setcount = i - 1
    setloc = searchmyloc(me, setcount, maxhcount)
    tmpsnum = me.pfriendlist[i].snum
    sprite(tmpsnum + 0).loc = setloc
    sprite(tmpsnum + 1).loc = setloc
    sprite(tmpsnum + 2).loc = setloc + me.ptextoffset
    if i > maxcharanum then
      tmp = 1
    else
      tmp = 0
    end if
    sendSprite(tmpsnum + 1, #setisscrollout, tmp)
  end repeat
  me.phexlist = [#hnum: maxhcount, #vnum: maxvcount, #vcount: vcount, #startingpoint: pfirstcharaloc - point(24, 24), #nextcharapos: me.pnextcharapos[2], #scrollnum: me.pscrollnum]
  checkscrollbutton(me)
  checkfolderscrollbutton(me)
end

on scrollfriend me, vnum
  me.pscrollnum = me.pscrollnum + vnum
  repeat with i = 1 to me.count(#pfriendlist)
    tmpsnum = me.pfriendlist[i].snum
    sprite(tmpsnum + 0).locV = sprite(tmpsnum + 0).locV + me.pnextcharapos[2] * vnum
    sprite(tmpsnum + 1).locV = sprite(tmpsnum + 1).locV + me.pnextcharapos[2] * vnum
    sprite(tmpsnum + 2).locV = sprite(tmpsnum + 2).locV + me.pnextcharapos[2] * vnum
  end repeat
  checkscrollbutton(me)
end

on scrollfolder me, vnum
  me.ptabscrollnum = me.ptabscrollnum + vnum
  repeat with i = 1 to me.count(#pfolderlist)
    tmpsnum = me.pfolderlist[i].snum
    sprite(tmpsnum + 0).locH = sprite(tmpsnum + 0).locH + me.pnextfolderwidth * vnum
    sprite(tmpsnum + 1).locH = sprite(tmpsnum + 1).locH + me.pnextfolderwidth * vnum
  end repeat
  checkfolderscrollbutton(me)
end

on checkscrollbutton me
  if me.pfriendlist <> [] then
    if sprite(me.pfriendlist.getLast().snum).locV <= me.pfirstcharaloc[2] + me.phexlist.vnum - 1 * me.pnextcharapos[2] then
      sendAllSprites(#hidescrollbottombutton)
    else
      sendAllSprites(#showscrollbottombutton)
    end if
    if sprite(me.pfriendlist[1].snum).locV >= me.pfirstcharaloc[2] then
      sendAllSprites(#hidescrolltopbutton)
    else
      sendAllSprites(#showscrolltopbutton)
    end if
  end if
end

on checkfolderscrollbutton me
  if me.count(#pfolderlist) then
    if sprite(me.pfolderlist.getLast().snum).locH = me.pfirstfolderloc[1] then
      sendAllSprites(#hidescrollrightbutton)
    else
      sendAllSprites(#showscrollrightbutton)
    end if
    if sprite(me.pfolderlist[1].snum).locH = me.pfirstfolderloc[1] then
      sendAllSprites(#hidescrollleftbutton)
    else
      sendAllSprites(#showscrollleftbutton)
    end if
  end if
end

on mouseDown me
  if voidp(the mouseMember) then
    if me.pselectlist <> [] then
      sendSprite(me.pselectlist.snum, #deleteselectmask)
    end if
  end if
  pass()
end

on setminsize me
  stagewidth = the stageRight - the stageLeft
  stageheight = the stageBottom - the stageTop
  tmprect = window("friend").rect
  if stagewidth < me.pminwidth then
    p3 = tmprect[1] + me.pminwidth
  else
    p3 = tmprect[3]
  end if
  if stageheight < me.pminheight then
    p4 = tmprect[2] + me.pminheight
  else
    p4 = tmprect[4]
  end if
  tmprect = rect(tmprect[1], tmprect[2], p3, p4)
  window("friend").rect = tmprect
end

on success me
  sendAllSprites(#stopwaiting)
end

on error me
  sendAllSprites(#stopwaiting)
end
