property myspritenum, myfolderid, myuserinfolist, myemotionlist, mycount, lastticks, stopanim, beforeselected, isselected, beforebg, beforemousepos, ismousedown, isdraging, pisfitibeam, pisontab, pisscrollout, pmyenabled, pmyviewmode, phexcount
global gcharacter, gnewmessage

on new me, vlist, snum
  me.myspritenum = snum
  me.myfolderid = 1
  me.lastticks = the ticks
  me.stopanim = 0
  setstatusid(me, vlist)
  me.beforeselected = 0
  me.isselected = 0
  me.isdraging = 0
  me.pisfitibeam = 0
  me.pisontab = 0
  me.pmyenabled = 1
  return me
end

on exitFrame me
  if me.pmyenabled then
    if not me.stopanim and me.pmyviewmode = #big then
      if the ticks - me.lastticks > me.myemotionlist.speed then
        me.lastticks = the ticks
        me.mycount = me.mycount + 1
        if me.mycount > me.myemotionlist.count(#pattern) then
          me.mycount = me.myemotionlist.loopstartnum
        end if
        sprite(me.myspritenum).member = me.myemotionlist.pattern[me.mycount]
      end if
    end if
    if not isdraging and me.ismousedown then
      if abs(the mouseH - me.beforemousepos[1]) > 5 or abs(the mouseV - me.beforemousepos[2]) > 5 then
        me.isdraging = 1
        sendAllSprites(#dragstart, sprite(me.myspritenum).member, me.pmyviewmode)
      end if
    end if
    if me.pisfitibeam and not pisontab then
      case me.pmyviewmode of
        #big:
          tmplist = [40, 40, 24, 30, 50, 40]
        #small:
          tmplist = [15, 11, 80, 10, 110, 90]
      end case
      myh = sprite(myspritenum).locH
      myv = sprite(myspritenum).locV
      if the mouseV >= myv - tmplist[2] and the mouseV < myv + tmplist[2] then
        if the mouseH >= myh - tmplist[1] and the mouseH <= myh + tmplist[3] then
          sendAllSprites(#fitibeam, me.phexcount, point(myh - tmplist[4], myv))
        else
          if the mouseH > myh + tmplist[3] and the mouseH < myh + tmplist[6] then
            sendAllSprites(#fitibeam, me.phexcount + 1, point(myh + tmplist[5], myv))
          end if
        end if
      end if
    end if
  end if
end

on initanimation me
  if me.myuserinfolist.connect then
    case me.pmyviewmode of
      #big:
        me.myemotionlist = gcharacter.getemotionlist(me.myuserinfolist.charid, me.myuserinfolist.emotionid)
        sprite(me.myspritenum - 1).member = gcharacter.getback(me.myuserinfolist.charid, me.myuserinfolist.connect)
        startanimation()
      #small:
        sprite(me.myspritenum).member = gcharacter.getcharacterlist(me.myuserinfolist.charid, me.myuserinfolist.emotionid).smallimages[2]
        sprite(me.myspritenum - 1).member = "dummy"
        stopanimation()
    end case
  else
    case me.pmyviewmode of
      #big:
        sprite(me.myspritenum).member = gcharacter.getemotionlist(me.myuserinfolist.charid, 0).pattern[1]
        sprite(me.myspritenum - 1).member = gcharacter.getback(me.myuserinfolist.charid, me.myuserinfolist.connect)
      #small:
        sprite(me.myspritenum).member = gcharacter.getcharacterlist(me.myuserinfolist.charid, me.myuserinfolist.emotionid).smallimages[1]
        sprite(me.myspritenum - 1).member = "dummy"
    end case
    stopanimation()
  end if
  me.beforebg = sprite(me.myspritenum - 1).member
end

on setstatusid me, vlist
  if myuserinfolist <> vlist then
    me.myuserinfolist = vlist
    me.mycount = 1
    initanimation(me)
  end if
end

on getstatus me
  return me.vlist
end

on stopanimation me
  stopanim = 1
end

on startanimation me
  stopanim = 0
end

on deleteselectmask me
  sprite(myspritenum - 1).member = me.beforebg
  sendAllSprites(#deleteselectlist, myuserinfolist.userid)
  me.isselected = 0
  sendSprite(myspritenum + 1, #rmvselect)
end

on domouseupscript me
  if isdraging then
    tmp = sendAllSprites(#wibeampos)
    if tmp <> -1 then
      sendAllSprites(#movefriendlist, tmp)
    end if
  end if
  me.ismousedown = 0
  me.isdraging = 0
  sendAllSprites(#dragstop)
end

on dragstart me
  me.pisfitibeam = 1
  me.phexcount = sendAllSprites(#getmycount, me.myspritenum)
end

on dragstop me
  me.pisfitibeam = 0
end

on deleteibeam me
  me.pisontab = 1
end

on showibeam me
  me.pisontab = 0
end

on setisscrollout me, vbool
  me.pisscrollout = vbool
end

on isscrollout me
  return me.pisscrollout
end

on setmyviewmode me, vmode
  me.pmyviewmode = vmode
  initanimation(me)
end

on enable me
  me.pmyenabled = 1
end

on disable me
  me.pmyenabled = 0
end

on mouseEnter me
  if me.pmyenabled then
    stagewidth = the stageRight - the stageLeft
    stageheight = the stageBottom - the stageTop
    centerh = stagewidth / 2
    centerv = stageheight / 2
    myh = sprite(myspritenum).locH
    myv = sprite(myspritenum).locV
    if myh + 277 < stagewidth then
      balloonposh = myh
    else
      if myh - 277 > 0 then
        balloonposh = myh - 277
      else
        balloonposh = centerh + myh - centerh / 2 - 138
      end if
    end if
    if myv + 72 < stageheight then
      balloonposv = myv + 48
    else
      if myv - 72 > 0 then
        balloonposv = myv - 24
      else
        balloonposv = centerv + myv - centerv / 2 + 12
      end if
    end if
    sendAllSprites(#popup, point(sprite(myspritenum).locH, sprite(myspritenum).locV), point(balloonposh, balloonposv), myuserinfolist)
    cursor([member("cur1_1"), member("cur1_2")])
  end if
end

on mouseLeave me
  sendAllSprites(#deletepopup)
  cursor(-1)
end

on mouseDown me
  if me.pmyenabled then
    sendAllSprites(#deletepopup)
    me.ismousedown = 1
    me.beforemousepos = point(the mouseH, the mouseV)
    tmplist = sendAllSprites(#getselectlist)
    if tmplist <> [] then
      sendSprite(tmplist.snum, #deleteselectmask)
    end if
    case me.pmyviewmode of
      #big:
        sprite(myspritenum - 1).member = "背景選択"
      #small:
        sprite(myspritenum - 1).member = "背景選択小"
    end case
    sendSprite(myspritenum + 1, #setselect)
    sendAllSprites(#setselectlist, [#folderid: myfolderid, #userid: myuserinfolist.userid, #snum: myspritenum])
    me.isselected = 1
  end if
end

on mouseUp me
  if me.pmyenabled then
    if the doubleClick then
      gnewmessage.openWindow([me.myuserinfolist.userid], 0)
    end if
    domouseupscript(me)
  end if
end

on mouseUpOutSide me
  if me.pmyenabled then
    domouseupscript(me)
  end if
end
