property truewidth, trueheight, mywidth, myheight, myangle, anglestep, stepnum, showstate, sizechangestep, myviewmode, mycharanum, myspritenum, pmyviewmode, myinfolist

on new me, vlist, snum
  myinfolist = vlist
  myspritenum = snum
  initanimation(me)
  sprite(myspritenum).visible = 1
  return me
end

on exitFrame me
  case showstate of
    #showing:
      mywidth = mywidth + sizechangestep
      myheight = myheight + sizechangestep
      myangle = myangle + anglestep
      if mywidth >= truewidth then
        mywidth = truewidth
        myheight = trueheight
        showstate = #show
        myangle = 0
      end if
      sprite(myspritenum).width = mywidth
      sprite(myspritenum).height = myheight
      sprite(myspritenum).rotation = myangle
    #hiding:
      mywidth = mywidth - sizechangestep
      myheight = myheight - sizechangestep
      myangle = myangle - anglestep
      if mywidth <= 1 then
        mywidth = 1
        myheight = 1
        showstate = #show
        myangle = 0
        sendAllSprites(#slidechara, myspritenum - 1)
        sprite(myspritenum).scriptInstanceList = []
        sprite(myspritenum).type = 0
        puppetSprite(myspritenum, 0)
        sprite(myspritenum - 1).type = 0
        puppetSprite(myspritenum - 1, 0)
        sprite(myspritenum + 1).scriptInstanceList = []
        sprite(myspritenum + 1).type = 0
        puppetSprite(myspritenum + 1, 0)
      end if
      sprite(myspritenum).width = mywidth
      sprite(myspritenum).height = myheight
      sprite(myspritenum).rotation = myangle
    #otherwise:
      nothing()
  end case
end

on deleteme me
  mywidth = truewidth
  myheight = trueheight
  sprite(myspritenum).width = mywidth
  sprite(myspritenum).height = myheight
  sprite(myspritenum).rotation = 0
  showstate = #hiding
end

on initanimation me
  if voidp(me.pmyviewmode) then
    me.pmyviewmode = #big
  end if
  case me.pmyviewmode of
    #big:
      truewidth = 48
      trueheight = 48
    #small:
      truewidth = 16
      trueheight = 16
  end case
  mywidth = truewidth
  myheight = trueheight
  myangle = 0
  sizechangestep = 4
  stepnum = truewidth - 1 / sizechangestep
  if stepnum = 0 then
    stepnum = 720
  end if
  anglestep = 720 / stepnum
  sprite(myspritenum).width = mywidth
  sprite(myspritenum).height = myheight
  sprite(myspritenum).rotation = myangle
  showstate = #show
end

on setmyviewmode me, vmode
  me.pmyviewmode = vmode
  initanimation(me)
end
