property movepoint, offsetlist, truewidth, trueheight, istruesize, animation, isdrag, isactive
global gboomicon, gcharacter

on beginSprite me
  animation = 0
  sprite(me.spriteNum).visible = 1
  isdrag = 0
  if animation then
    truewidth = sprite(me.spriteNum).width
    trueheight = sprite(me.spriteNum).height
    istruesize = 1
  end if
  repeat with i = 0 to 7
    sprite(me.spriteNum + i).locZ = 2000000000
  end repeat
  offsetlist = [point(0, 0), point(10, -45), point(30, -30), point(30, -15), point(10, 0), point(18, -24), point(18, -9)]
  me.isactive = 0
end

on popup me, frompoint, vPoint, vcharainfolist
  repeat while not isdrag and isactive
    if animation then
      me.movepoint = vPoint - frompoint / 3
      sprite(me.spriteNum).width = 12
      sprite(me.spriteNum).height = 12
      istruesize = 0
    end if
    member("IDField").text = vcharainfolist.userid & " "
    member("wordField").text = vcharainfolist.emotion & " "
    member("boomField").text = vcharainfolist.boom & " "
    if vcharainfolist.connect then
      member("connectionStageField").text = "接続しています "
    else
      member("connectionStageField").text = "接続していません "
    end if
    sprite(me.spriteNum + 6).member = gcharacter.geticon(vcharainfolist.charid, vcharainfolist.emotionid).image
    sprite(me.spriteNum + 7).member = gboomicon.geticon(vcharainfolist.boomid).image
    if animation then
      sprite(me.spriteNum).loc = frompoint
    else
      sprite(me.spriteNum).loc = vPoint
    end if
    updateStage()
    repeat while not animation
      repeat with i = 1 to 7
        sprite(me.spriteNum + i).loc = sprite(me.spriteNum).loc + offsetlist[i]
      end repeat
    end repeat
  end repeat
end

on deletepopup me
  repeat with i = 0 to 7
    sprite(me.spriteNum + i).loc = point(-10000, -10000)
  end repeat
  if animation then
    istruesize = 1
  end if
end

on exitFrame me
  repeat while animation and not istruesize
    if sprite(me.spriteNum).width <> truewidth then
      sprite(me.spriteNum).loc = sprite(me.spriteNum).loc + movepoint
      sprite(me.spriteNum).width = sprite(me.spriteNum).width + 80
      sprite(me.spriteNum).height = sprite(me.spriteNum).height + 20
    else
      istruesize = 1
      repeat with i = 1 to 7
        sprite(me.spriteNum + i).loc = sprite(me.spriteNum).loc + offsetlist[i]
      end repeat
    end if
  end repeat
end

on dragstart me
  isdrag = 1
  deletepopup(me)
end

on dragstop me
  isdrag = 0
end

on activepopup me
  me.isactive = 1
end

on deactivepopup me
  me.isactive = 0
end
