property pmaxnum, func

on keyDown me
  if the keyCode = 36 then
    do(func)
  else
    if me.length() < me.pmaxnum then
      pass()
    else
      sprite(me.spriteNum).member.text = char 1 to sprite(me.spriteNum).member.text.length - 1 of the text of the member of sprite(the spriteNum of me)
    end if
  end if
end

on length me
  cnt = 0
  repeat with i = 1 to sprite(me.spriteNum).member.text.length
    cnt = cnt + chartobyte(me, char i of the text of the member of sprite(the spriteNum of me))
  end repeat
  return cnt
end

on chartobyte me, v
  tmp = charToNum(v)
  if tmp > 255 then
    return 2
  else
    return 1
  end if
end

on getPropertyDescriptionList me
  list = [:]
  addProp(list, #pmaxnum, [#comment: "最大文字数(Byte数):", #format: #integer, #default: 0])
  addProp(list, #func, [#comment: "リターン時呼び出す関数", #format: #symbol, #default: ""])
  return list
end
