property mcurpage, mitemlist, mrow, mcolumn, mcurline, mpos, mleft, mtop, minterval, mindex, mtopspritenum

on new me, itemlist, id, col, row, left, top, topspritenum
  me.mpos = 0
  me.mcurpage = 0
  me.mcurline = 0
  me.mitemlist = itemlist
  me.mcolumn = col
  me.mrow = row
  me.mleft = left
  me.mtop = top
  me.minterval = 24
  me.mtopspritenum = topspritenum
  me.mindex = -1
  me.update()
  return me
end

on delete me
  repeat with i in me.mitemlist
    erase(member("label" & i))
  end repeat
  sendAllSprites(#clear)
end

on update me, msg
  repeat with i in me.mitemlist
    newfield = new(#field)
    newfield.name = "label" & i
    newfield.forecolor = 255
    newfield.backcolor = 245
    newfield.text = i
    newfield.font = "ＭＳ ゴシック"
    newfield.fontSize = 12
    rect = newfield.rect
    rect.right = 180
    newfield.rect = rect
    me.minterval = newfield.lineHeight + 4
  end repeat
  me._update()
end

on _update me
  sendAllSprites(#clear)
  repeat with i = 0 to mrow - 1
    repeat with j = 0 to mcolumn - 1
      pos = me.mpos + me.mcolumn * i + j
      if pos < me.count(#mitemlist) then
        new(script("_アクセス拒否リスト"), pos, me.mitemlist[pos + 1], mtopspritenum + me.mcolumn * i + j, me.mleft, me.mtop + me.minterval * i)
      end if
    end repeat
  end repeat
  sendAllSprites(#_select, mindex)
end

on scrollByLine me, amount
  pos = me.mcolumn * me.mcurline + amount
  if me.mcolumn = 1 then
    m = me.mcolumn * me.mrow
  else
    m = me.mcolumn * me.mrow - 1
  end if
  if pos >= 0 and pos <= me.count(#mitemlist) - m then
    me.mcurline = me.mcurline + amount
    me.mpos = pos
  end if
  me._update()
end

on select me, index
  me.mindex = index
end

on getselectid me
  if me.mindex <> -1 then
    return me.mitemlist[me.mindex + 1]
  end if
end
