property mspritenum, mnormalimage, mhiliteimage, mdownimage, mtracking, minfo
global guser

on new me, spnum, info, x, y
  me.mspritenum = spnum
  me.minfo = info
  me.mnormalimage = me.minfo.normal
  me.mhiliteimage = me.minfo.hilite
  me.mdownimage = me.minfo.down
  me.mtracking = 0
  sprite(me.mspritenum).type = 1
  sprite(me.mspritenum).puppet = 1
  sprite(me.mspritenum).ink = 8
  sprite(me.mspritenum).forecolor = 255
  sprite(me.mspritenum).backcolor = 0
  sprite(me.mspritenum).member = me.mnormalimage
  sprite(me.mspritenum).loc = point(x, y)
  sprite(me.mspritenum).scriptInstanceList.add(me)
  return me
end

on endSprite me
  cursor(-1)
end

on clear me
  sprite(me.mspritenum).scriptInstanceList = []
  sprite(me.mspritenum).puppet = 0
  sprite(me.mspritenum).type = 0
end

on mouseDown me
  if objectp(guser) then
    if guser.getsound() then
      puppetSound(2, "windowOpen")
    end if
  end if
  sprite(me.mspritenum).member = me.mdownimage
  me.mtracking = 1
end

on mouseUp me
  if me.mtracking then
    sprite(me.mspritenum).member = me.mhiliteimage
    if objectp(guser) then
      if me.minfo.path <> guser.getskin() then
        setskin(me.minfo.path)
      end if
    end if
  end if
  me.mtracking = 0
end

on mouseEnter me
  cursor([member("cur1_1", castLib("skin")), member("cur1_2", castLib("skin"))])
  if me.mtracking then
    sprite(me.mspritenum).member = me.mdownimage
  else
    sprite(me.mspritenum).member = me.mhiliteimage
  end if
end

on mouseLeave me
  cursor(-1)
  sprite(me.mspritenum).member = me.mnormalimage
end

on mouseUpOutSide me
  me.mtracking = 0
end
