global guser, gchatroom, gnewmessage, gskin

on prepareMovie
  _setskin()
end

on _setskin
  if not voidp(guser) then
    skin = guser.getskin()
    if castLib("skin").fileName <> skin then
      castLib("skin").fileName = skin
    end if
  end if
end

on startMovie
  gskin = []
  filenamelist = directorytolist(the moviePath & "..¥skins¥")
  if objectp(guser) then
    currentskin = guser.getskin()
  end if
  the itemDelimiter = "¥"
  skindir = the moviePath
  delete item the number of items in skindir - 1 of skindir
  skindir = skindir & "skins¥"
  repeat with i in filenamelist
    path = skindir & i
    if currentskin <> path then
      castLib("buffer").fileName = path
      if member(1, "buffer").type = #text then
        plist = value(member(1, "buffer").text)
        if listp(plist) then
          if getaProp(plist, #fileType) = #skin then
            plist = [:]
            plist.addProp(#path, path)
            pos = findEmpty(member(100))
            duplicate(member(2, "buffer"), member(pos))
            plist.addProp(#normal, member(pos))
            pos = findEmpty(member(100))
            duplicate(member(3, "buffer"), member(pos))
            plist.addProp(#hilite, member(pos))
            pos = findEmpty(member(100))
            duplicate(member(4, "buffer"), member(pos))
            plist.addProp(#down, member(pos))
            gskin.add(plist)
          end if
        end if
      end if
      castLib("buffer").fileName = the moviePath & "buffer.cst"
    else
      plist = [:]
      plist.addProp(#path, path)
      pos = findEmpty(member(100))
      duplicate(member(2, "skin"), member(pos))
      plist.addProp(#normal, member(pos))
      pos = findEmpty(member(100))
      duplicate(member(3, "skin"), member(pos))
      plist.addProp(#hilite, member(pos))
      pos = findEmpty(member(100))
      duplicate(member(4, "skin"), member(pos))
      plist.addProp(#down, member(pos))
      gskin.add(plist)
    end if
  end repeat
end

on stopMovie me
  gskin = 0
end

on closeWindow
  go("dummy")
end

on setskin path
  if objectp(guser) then
    guser.setskin(path)
    tell the stage
      castLib("skin").fileName = guser.getskin()
    end tell
    if windowPresent("publicChat") then
      tell window("publicChat")
        castLib("skin").fileName = guser.getskin()
      end tell
    end if
    if windowPresent("search") then
      tell window("search")
        castLib("skin").fileName = guser.getskin()
      end tell
    end if
    if windowPresent("friend") then
      tell window("friend")
        castLib("skin").fileName = guser.getskin()
      end tell
    end if
    if objectp(gchatroom) then
      gchatroom.setskin()
    end if
    if objectp(gnewmessage) then
      gnewmessage.setskin()
    end if
    castLib("skin").fileName = guser.getskin()
  end if
end
