property mroom, mspritenum, misselected, mindex, menabled
global gconnection, gchatroom

on new me, index, msg, spriteNum, h, v
  me.mindex = index
  me.mroom = msg
  me.mspritenum = spriteNum
  sprite(me.mspritenum).type = 1
  sprite(me.mspritenum).puppet = 1
  sprite(me.mspritenum).member = "label" & msg.roomid
  sprite(me.mspritenum).loc = point(h, v)
  sprite(me.mspritenum).scriptInstanceList.add(me)
  me.menabled = 1
  return me
end

on clear me
  sprite(me.mspritenum).scriptInstanceList = []
  sprite(me.mspritenum).puppet = 0
  sprite(me.mspritenum).type = 0
end

on mouseEnter me
  if me.menabled then
    if not me.misselected then
      sprite(me.mspritenum).member.forecolor = 0
      sprite(me.mspritenum).member.backcolor = 18
    end if
  end if
end

on mouseLeave me
  if not me.misselected then
    sprite(me.mspritenum).member.forecolor = 255
    sprite(me.mspritenum).member.backcolor = 18
  end if
end

on mouseUp me
  if the doubleClick then
    if objectp(gchatroom) then
      if the windowList.count < 16 then
        if gchatroom.getnumofpublicrooms() < 10 then
          if objectp(gconnection) then
            gconnection.send("join" && me.mroom.roomid)
          end if
        else
          alert("同時に参加できるパブリックチャットは１０部屋までです。")
        end if
        if the windowList.count = 16 then
          alert("これ以上ウィンドウを開くことはできません。")
        end if
      else
        alert("ウィンドウを開くことができません。")
      end if
    end if
  end if
end

on mouseDown me
  me.misselected = 1
  sprite(me.mspritenum).member.forecolor = 0
  sprite(me.mspritenum).member.backcolor = 61
  sendAllSprites(#_select, me.mindex)
  sendAllSprites(#select, me.mindex)
end

on _select me, index
  if index <> me.mindex then
    me.misselected = 0
    if sprite(me.mspritenum).member.forecolor <> 255 then
      sprite(me.mspritenum).member.forecolor = 255
    end if
    if sprite(me.mspritenum).member.backcolor <> 18 then
      sprite(me.mspritenum).member.backcolor = 18
    end if
  else
    me.misselected = 1
  end if
end

on listenable me
  me.menabled = 1
end

on listdisable me
  me.menabled = 0
end
