property mhilite, mnormalimage, mdownimage, mhiliteimage, mgroup, marea, mareaid, mtracking
global guser

on beginSprite me
  me.mtracking = 0
  me.mnormalimage = sprite(me.spriteNum).member
  if me.mareaid = sendAllSprites(#_getselectareaid) then
    me.mhilite = 1
    sprite(me.spriteNum).member = me.mdownimage
  else
    me.mhilite = 0
  end if
end

on hilite me, group, spnum
  if group = me.mgroup and spnum <> me.spriteNum then
    me.mhilite = 0
    sprite(me.spriteNum).member = me.mnormalimage
  end if
end

on mouseDown me
  if objectp(guser) then
    if guser.getsound() then
      puppetSound(2, "se9")
    end if
  end if
  me.mtracking = 1
  sprite(me.spriteNum).member = me.mdownimage
end

on mouseUp me
  if me.mtracking then
    if not me.mhilite then
      me.mhilite = 1
      sendAllSprites(#hilite, me.mgroup, me.spriteNum)
    else
      me.mhilite = 0
      sprite(me.spriteNum).member = me.mhiliteimage
    end if
  end if
  me.mtracking = 0
end

on mouseUpOutSide me
  me.mtracking = 0
end

on setinfo me, info
  me.marea = info.area
  me.mareaid = info.areaid
end

on mouseEnter me
  cursor([member("cur1_1", castLib("skin")), member("cur1_2", castLib("skin"))])
  sendAllSprites(#showhint, me.marea, sprite(me.spriteNum).locH, sprite(me.spriteNum).bottom, 15)
  if me.mtracking then
    sprite(me.spriteNum).member = me.mdownimage
  else
    if not me.mhilite then
      sprite(me.spriteNum).member = me.mhiliteimage
    end if
  end if
end

on mouseLeave me
  cursor(-1)
  sendAllSprites(#hidehint)
  if not me.mhilite then
    sprite(me.spriteNum).member = me.mnormalimage
  end if
end

on gethilite me
  return me.mhilite
end

on getselectareaid me
  if me.mhilite then
    return me.mareaid
  end if
end

on getPropertyDescriptionList
  memnum = sprite(the currentSpriteNum).member.memberNum
  cstnum = sprite(the currentSpriteNum).member.castLibNum
  plist = [#mhiliteimage: [#comment: "ハイライトのイメージ:", #format: #graphic, #default: member(memnum + 1, cstnum)], #mdownimage: [#comment: "押されたイメージ:", #format: #graphic, #default: member(memnum + 2, cstnum)], #mgroup: [#comment: "グループ", #format: #symbol, #default: #グループ1], #marea: [#comment: "エリア名", #format: #string, #default: "エリア名"], #mareaid: [#comment: "エリアId", #format: #integer, #default: 0]]
  return plist
end
