property mcurpage, mitemlist, mrow, mcolumn, mcurline, mpos, mleft, mtop, minterval, mindex, mtopspritenum

on new me, itemlist, id, col, row, left, top, topspritenum
  me.mpos = 0
  me.mcurpage = 0
  me.mcurline = 0
  me.mitemlist = duplicate(itemlist)
  me.mcolumn = col
  me.mrow = row
  me.mleft = left
  me.mtop = top
  me.minterval = 18
  me.mtopspritenum = topspritenum
  me.mindex = -1
  me._updateresult()
  return me
end

on delete me
  repeat with i in me.mitemlist
  end repeat
  me.mitemlist = []
  sendAllSprites(#clearresult)
end

on updateresult me, type, msg
  sendSprite(2, #enable)
  case type of
    #direct:
      go("direct")
    #cond:
      go("cond")
    #affin:
      go("affin")
  end case
  me.delete()
  me.mindex = -1
  me.mpos = 0
  me.mcurline = 0
  me.mitemlist = duplicate(msg)
  me.createlabel(type)
  me._updateresult()
end

on _updateresult me
  sendAllSprites(#clearresult)
  repeat with i = 0 to mrow - 1
    repeat with j = 0 to mcolumn - 1
      pos = me.mpos + me.mcolumn * i + j
      if pos < me.count(#mitemlist) then
        spnum = mtopspritenum + 2 * me.mcolumn * i + j
        new(script("検索結果"), pos, me.mitemlist[pos + 1], spnum, me.mleft, me.mtop + me.minterval * i)
      end if
    end repeat
  end repeat
  sendAllSprites(#_selectresult, mindex)
end

on scrollbylineresult me, amount
  pos = me.mcolumn * me.mcurline + amount
  if me.mcolumn = 1 then
    m = me.mcolumn * me.mrow
  else
    m = me.mcolumn * me.mrow - 1
  end if
  if pos >= 0 and pos <= me.count(#mitemlist) - m then
    me.mcurline = me.mcurline + amount
    me.mpos = pos
  end if
  me._updateresult()
end

on selectresult me, index
  me.mindex = index
end

on getselectidresult me
  if me.mindex <> -1 then
    return me.mitemlist[me.mindex + 1].userid
  end if
end

on createlabel me, type
  repeat with i in me.mitemlist
    newfield = new(#field)
    newfield.name = "label" & stringtonum(i.userid)
    newfield.forecolor = 255
    newfield.backcolor = 245
    newfield.margin = 4
    case type of
      #direct:
        newfield.text = me.direct(i)
      #cond:
        newfield.text = me.cond(i)
      #affin:
        newfield.text = me.affin(i)
    end case
    newfield.font = "ＭＳ ゴシック"
    newfield.fontSize = 12
    rect = newfield.rect
    rect.right = 300
    rect.bottom = 18
    newfield.rect = rect
  end repeat
end

on direct me, msg
  str = ""
  str = str & msg.userid
  str = me.setlength(str, 17)
  if msg.area <> "公開されていません" then
    str = str & msg.area
  else
    str = str & "？"
  end if
  str = me.setlength(str, 26)
  if msg.birth <> "公開されていません" then
    str = str & msg.birth
  else
    str = str & "？"
  end if
  return str
end

on cond me, msg
  str = ""
  str = str & msg.userid
  str = me.setlength(str, 17)
  if msg.area <> "公開されていません" then
    str = str & msg.area
  else
    str = str & "？"
  end if
  str = me.setlength(str, 26)
  if msg.birth <> "公開されていません" then
    str = str & msg.birth
  else
    str = str & "？"
  end if
  return str
end

on affin me, msg
  str = ""
  str = str & msg.userid
  str = me.setlength(str, 17)
  if msg.area <> "公開されていません" then
    str = str & msg.area
  else
    str = str & "？"
  end if
  str = me.setlength(str, 26)
  if msg.birth <> "公開されていません" then
    str = str & msg.birth
  else
    str = str & "？"
  end if
  str = me.setlength(str, 37)
  str = str & msg.affinity & "％"
  return str
end

on setlength me, str, len
  repeat while me.length(str) < len
    str = str & " "
  end repeat
  return str
end

on length me, str
  len = 0
  repeat with i = 1 to str.length
    if charToNum(char i of str) > 255 then
      len = len + 2
    else
      len = len + 1
    end if
  end repeat
  return len
end
