global gversion, gconnection, guser, gfriendlist, gchatroom, gpublicchatlist, gpersonalinfo, gdeniedlist, gsearch

on parsereceivestring str
  the itemDelimiter = " "
  command = item 1 of str
  delete item 1 of str
  if voidp(integer(command)) then
    case symbol(command) of
      #error:
        case gconnection.getLast().command of
          #friend, #folder:
            gfriendlist.receiveerror(gconnection.getLast().content)
          #search:
            gsearch.receiveerror()
        end case
        case gconnection.getstatus() of
          #未接続:
          #接続:
            plist = parseerror(str)
            alert(plist.errormsg)
            if objectp(guser) then
              if plist.errorcode = 100 then
                guser.setuserid("")
              else
                if plist.errorcode = 103 then
                  guser.setpassword("")
                end if
              end if
            end if
            openlogin()
          otherwise:
            if gconnection.getissend() = 0 then
              gconnection.sendstring("ok")
            end if
            plist = parseerror(str)
            alert(plist.errormsg)
            gconnection.sendbuffer()
        end case
      #ok:
        case gconnection.getLast().command of
          #recv:
            gconnection.receiveok()
          #send:
          #join:
            plist = gconnection.getLast().content
            gchatroom.addpublic(plist, gpublicchatlist.getname(plist.roomid))
          #list:
            case gconnection.getLast().content.option of
              #eventroom:
                gpublicchatlist.receiveok()
              #denied:
                gdeniedlist.receiveok(gconnection.getLast())
              #area:
                gsearch.receivelistok()
            end case
          #friend:
            gfriendlist.sendfriend(gconnection.getLast().content)
          #folder:
            gfriendlist.sendfolder(gconnection.getLast().content)
          #info:
            gpersonalinfo.receiveok()
          #allow, #deny:
            gdeniedlist.receiveok(gconnection.getLast())
        end case
        case gconnection.getstatus() of
          #接続:
            gconnection.setstatus(#フォルダ情報の取得)
            gconnection.sendstring("folder list")
            sendAllSprites(#showstatus, "フォルダ情報の取得中...")
          #フォルダ情報の取得:
            gconnection.setstatus(#ともだち情報の取得)
            gfriendlist.test()
            gconnection.sendbuffer()
          #ともだち情報の取得:
            gconnection.setstatus(#アクセス拒否リストの取得)
            gconnection.send("list denied")
            gconnection.sendbuffer()
            sendAllSprites(#showstatus, "アクセス拒否リストの取得中...")
          #アクセス拒否リストの取得:
            gconnection.setstatus(#ログイン終了)
            gconnection.sendbuffer()
          #キャラクターの選択:
            openinit()
          otherwise:
            gconnection.sendbuffer()
        end case
      #vers:
        gconnection.sendstring(gversion)
      #login:
        sendAllSprites(#showstatus, "IDとパスワードの確認中...")
        if gconnection.getstatus() = #未接続 then
          gconnection.setstatus(#接続)
          gconnection.sendstring(guser.getuserid())
        end if
      #passwd:
        gconnection.sendstring(guser.getpassword())
      #require:
        gconnection.setstatus(#キャラクターの選択)
      #status:
        if gconnection.getsend() then
          if gconnection.getstatus() = #接続 then
            guser.initstatus(parsestatus(str))
          else
            if gconnection.getstatus() = #ともだち情報の取得 then
              gfriendlist.addstatus(parsestatus(str), gconnection.getLast().content.folderid)
            else
              if gconnection.getstatus() = #キャラクターの選択 then
                guser.receivestatus(parsestatus(str))
                gconnection.setstatus(#接続)
              else
                case gconnection.getLast().command of
                  #member:
                    gchatroom.addstatus(parsestatus(str), gconnection.getLast().content.roomid)
                  #friend:
                    gfriendlist.addstatus(parsestatus(str), gconnection.getLast().content.folderid)
                  #folder:
                    gfriendlist.receivestatus(parsestatus(str), gconnection.getLast().content.folderid)
                  #search:
                    gsearch.receivestatus(parsesearchstatus(str))
                  #info:
                    gpersonalinfo.receivestatus(parsestatus(str))
                  otherwise:
                    gconnection.sendstring("ok")
                end case
              end if
            end if
          end if
        else
          gconnection.sendstring("ok")
          plist = parsestatus(str)
          gchatroom.receivestatus(plist)
          gfriendlist.receivestatus(plist)
          guser.receivestatus(plist)
          gpersonalinfo.setstatus(plist)
        end if
      #folder:
        case gconnection.getLast().command of
          #folder:
            case gconnection.getLast().content.option of
              #list:
                gfriendlist.receivefolder(parsefolder(str))
            end case
        end case
      #name:
        gpersonalinfo.receivename(str)
      #sex:
        gpersonalinfo.receivesex(integer(str))
      #birth:
        gpersonalinfo.receivebirth(str)
      #area:
        gpersonalinfo.receivearea(str)
      #msg:
        if gconnection.getLast().command = #info then
          gpersonalinfo.receivemsg(str)
        else
          gconnection.sendstring("ok")
          plist = parsemsg(str)
          if plist.roomid then
            gchatroom._receivemsg(plist)
          else
            alert(plist.msg)
          end if
        end if
      #watched:
        gconnection.sendstring("ok")
        alert("「" & str & "」さんがあなたのことを「トモダチリスト」に登録しました。")
      #joined:
        gconnection.sendstring("ok")
        gchatroom.receivejoined(parsejoined(str))
      #retired:
        gconnection.sendstring("ok")
        gchatroom.receiveretired(parseretired(str))
      #denied:
        if gconnection.getLast().command = #list then
          plist = parsedenied(str)
          gdeniedlist.receivedeniedlist(plist)
        else
          gconnection.sendstring("ok")
          plist = parsedenied(str)
          gfriendlist.receivedenied(plist)
          alert("「" & plist.userid & "」さんへのアクセスは拒否されました。")
        end if
      #result:
        gsearch.receiveresult(integer(str))
      #hit:
        gsearch.receivehit(integer(str))
      #cond:
        gsearch.receivestatus(parsecond(str))
      #affin:
        gsearch.receivestatus(parseaffin(str))
      #end:
        gsearch.receiveend()
        gconnection.sendstring("ok")
    end case
  else
    case gconnection.getLast().command of
      #invite:
        gchatroom.setreserveroomid(integer(command))
      #list:
        case gconnection.getLast().content.option of
          #public, #eventroom:
            plist = parsepublicchatlist(str)
            plist.addProp(#roomid, integer(command))
            gpublicchatlist.receiveroomlist(plist)
          #area:
            plist = [:]
            plist.addProp(#areaid, integer(command))
            plist.addProp(#area, str)
            gsearch.receivearealist(plist)
        end case
      #folder:
        plist = gconnection.getLast().content
        plist.addProp(#folderid, integer(command))
        gfriendlist.receivefolder(plist)
      #search:
        gsearch.receivesearchid(integer(command), gconnection.getLast().content.option)
      #param:
        if windowPresent("init") then
          tell window("init")
            sendAllSprites(#setparam, integer(command))
          end tell
        end if
    end case
  end if
end

on parsesendstring str
  the itemDelimiter = " "
  command = symbol(item 1 of str)
  delete item 1 of str
  case command of
    #invite:
      plist = parseinvite(str)
      plist.setaProp(#userid, guser.getuserid())
      if plist.roomid = 0 then
        gchatroom.addreserve(plist)
      end if
    #msg:
      plist = parsemsg2(str)
      plist.addProp(#userid, guser.getuserid())
      gchatroom.sendmsg(plist)
    #emotion:
      plist = parseemotion(str)
      guser.sendemotion(plist)
      status = guser.getstatus()
      gchatroom.receivestatus(status)
      gfriendlist.receivestatus(status)
      guser.receivestatus(status)
    #boom:
      plist = parseboom(str)
      guser.sendboom(plist)
      status = guser.getstatus()
      gchatroom.receivestatus(status)
      gfriendlist.receivestatus(status)
      guser.receivestatus(status)
    #join:
      plist = parsejoin(str)
    #member:
      plist = parsemember(str)
    #friend:
      plist = parsefriend2(str)
    #folder:
      plist = parsefolder2(str)
    #list:
      plist = parselist(str)
    #info:
      plist = parseinfo(str)
    #deny:
      plist = parsedeny2(str)
    #allow:
      plist = parseallow(str)
    #search:
      plist = parsesearch2(str)
      gsearch.sendsearch(plist)
    #quit:
      guser.disconnect()
  end case
  return [#command: command, #content: plist]
end

on parseerror str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#errorcode, integer(item 1 of str))
  delete item 1 of str
  plist.addProp(#errormsg, str)
  return plist
end

on parsefolder str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#folderid, integer(item 1 of str))
  plist.addProp(#name, item 2 of str)
  return plist
end

on parsefolder2 str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#option, symbol(item 1 of str))
  case plist.option of
    #add:
      plist.addProp(#name, item 2 of str)
    #rmv:
      plist.addProp(#folderid, integer(item 2 of str))
    #renum:
      member = []
      repeat with i = 2 to the number of items in str
        member.add(integer(item i of str))
      end repeat
      plist.addProp(#member, member)
    #rename:
      plist.addProp(#folderid, integer(item 2 of str))
      plist.addProp(#name, item 3 of str)
    #show:
      plist.addProp(#folderid, integer(item 2 of str))
    #hide:
      plist.addProp(#folderid, integer(item 2 of str))
  end case
  return plist
end

on parsefriend2 str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#option, symbol(item 1 of str))
  case plist.option of
    #add:
      plist.addProp(#folderid, integer(item 2 of str))
      plist.addProp(#userid, item 3 of str)
    #rmv:
      plist.addProp(#folderid, integer(item 2 of str))
      plist.addProp(#userid, item 3 of str)
    #renum:
      plist.addProp(#folderid, integer(item 2 of str))
      member = []
      repeat with i = 3 to the number of items in str
        member.add(item i of str)
      end repeat
      plist.addProp(#member, member)
    #move:
      plist.addProp(#src, integer(item 2 of str))
      plist.addProp(#dest, integer(item 3 of str))
      plist.addProp(#userid, item 4 of str)
    #list:
      plist.addProp(#folderid, integer(item 2 of str))
  end case
  return plist
end

on parsestatus str
  plist = [:]
  the itemDelimiter = "="
  plist.addProp(#userid, item 1 of str)
  delete item 1 of str
  the itemDelimiter = ","
  plist.addProp(#charid, integer(item 1 of str))
  plist.addProp(#emotionid, integer(item 2 of str))
  plist.addProp(#boomid, integer(item 3 of str))
  plist.addProp(#emotion, item 4 of str)
  plist.addProp(#boom, item 5 of str)
  plist.addProp(#connect, integer(item 6 of str))
  return plist
end

on parseemotion str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#emotionid, integer(item 1 of str))
  delete item 1 of str
  plist.addProp(#emotion, str)
  return plist
end

on parseboom str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#boomid, integer(item 1 of str))
  delete item 1 of str
  plist.addProp(#boom, str)
  return plist
end

on parsemsg str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#roomid, integer(item 1 of str))
  delete item 1 of str
  plist.addProp(#userid, item 1 of str)
  delete item 1 of str
  plist.addProp(#msg, str)
  return plist
end

on parsemsg2 str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#roomid, integer(item 1 of str))
  delete item 1 of str
  plist.addProp(#msg, str)
  return plist
end

on parsewatched str
  plist = [:]
  plist.addProp(#userid, str)
  return plist
end

on parseinvite str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#roomid, integer(item 1 of str))
  plist.addProp(#userid, item 2 of str)
  plist.addProp(#msg, item 3 of str)
  return plist
end

on parsejoin str
  plist = [:]
  plist.addProp(#roomid, integer(str))
  return plist
end

on parsejoined str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#roomid, integer(item 1 of str))
  delete item 1 of str
  plist.addProp(#status, parsestatus(str))
  return plist
end

on parsemember str
  plist = [:]
  plist.addProp(#roomid, integer(str))
  return plist
end

on parseretired str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#roomid, integer(item 1 of str))
  plist.addProp(#userid, item 2 of str)
  return plist
end

on parselist str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#option, symbol(str))
  return plist
end

on parsepublicchatlist str
  plist = [:]
  the itemDelimiter = ","
  plist.addProp(#name, item 1 of str)
  plist.addProp(#member, integer(item 2 of str))
  return plist
end

on parseallow str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#userid, str)
  return plist
end

on parsedeny2 str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#userid, str)
  return plist
end

on parsedeny str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#userid, str)
  return plist
end

on parsedenied str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#userid, str)
  return plist
end

on parseinfo str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#userid, str)
  return plist
end

on parsesearch2 str
  plist = [:]
  the itemDelimiter = " "
  plist.addProp(#option, symbol(item 1 of str))
  case plist.option of
    #direct:
      plist.addProp(#userid, item 2 of str)
    #cond:
      delete item 1 of str
      the itemDelimiter = ","
      plist.addProp(#areaid, integer(item 1 of str))
      plist.addProp(#sex, integer(item 2 of str))
      plist.addProp(#age, integer(item 3 of str))
      plist.addProp(#freeword, item 4 of str)
      plist.addProp(#boomid, integer(item 5 of str))
      plist.addProp(#connect, integer(item 6 of str))
    #affin:
      delete item 1 of str
      the itemDelimiter = ","
      plist.addProp(#encounter, integer(item 1 of str))
      plist.addProp(#connect, integer(item 2 of str))
  end case
  return plist
end

on parsesearchstatus str
  plist = [:]
  the itemDelimiter = "="
  plist.addProp(#userid, item 1 of str)
  delete item 1 of str
  the itemDelimiter = ","
  plist.addProp(#charid, integer(item 1 of str))
  plist.addProp(#emotionid, integer(item 2 of str))
  plist.addProp(#boomid, integer(item 3 of str))
  plist.addProp(#emotion, item 4 of str)
  plist.addProp(#boom, item 5 of str)
  plist.addProp(#connect, integer(item 6 of str))
  plist.addProp(#sex, integer(item 7 of str))
  plist.addProp(#area, item 8 of str)
  plist.addProp(#birth, item 9 of str)
  return plist
end

on parsecond str
  plist = [:]
  the itemDelimiter = "="
  plist.addProp(#userid, item 1 of str)
  str = item 2 of str
  the itemDelimiter = ","
  plist.addProp(#charid, integer(item 1 of str))
  plist.addProp(#emotionid, integer(item 2 of str))
  plist.addProp(#boomid, integer(item 3 of str))
  plist.addProp(#emotion, item 4 of str)
  plist.addProp(#boom, item 5 of str)
  plist.addProp(#connect, integer(item 6 of str))
  plist.addProp(#sex, integer(item 7 of str))
  plist.addProp(#area, item 8 of str)
  plist.addProp(#birth, item 9 of str)
  return plist
end

on parseaffin str
  plist = [:]
  the itemDelimiter = "="
  plist.addProp(#userid, item 1 of str)
  str = item 2 of str
  the itemDelimiter = ","
  plist.addProp(#charid, integer(item 1 of str))
  plist.addProp(#emotionid, integer(item 2 of str))
  plist.addProp(#boomid, integer(item 3 of str))
  plist.addProp(#emotion, item 4 of str)
  plist.addProp(#boom, item 5 of str)
  plist.addProp(#connect, integer(item 6 of str))
  plist.addProp(#sex, integer(item 7 of str))
  plist.addProp(#area, item 8 of str)
  plist.addProp(#birth, item 9 of str)
  plist.addProp(#affinity, integer(item 10 of str))
  return plist
end
