property mconnection, mbuffer, missend, mstatus, mlaststring, misfirst
global gdebug, gtickcount

on new me
  me.mbuffer = []
  me.missend = 1
  me.mconnection = 0
  me.mstatus = #未接続
  me.misfirst = 1
  return me
end

on sendstring me, str
  if objectp(me.mconnection) then
    crlf = numToChar(13) & numToChar(10)
    str = replace(str, crlf, "$%0d%0a$")
    if gdebug = "imj" then
      put "-->" && str
    end if
    err = sendnetmessage(me.mconnection, "", "", str & numToChar(13) & numToChar(10))
    plist = parsesendstring(str)
    me.mlaststring = plist
  end if
end

on send me, str
  if objectp(me.mconnection) then
    me.mbuffer.add(str)
    if not me.missend then
      me.missend = 1
      sendstring(me, "send")
    end if
  end if
end

on sendbuffer me
  if me.count(#mbuffer) then
    if me.missend then
      str = me.mbuffer[1]
      me.mbuffer.deleteAt(1)
      sendstring(me, str)
    else
    end if
  else
    if me.missend then
      sendstring(me, "recv")
    end if
  end if
end

on connect me
  initialize()
  if not objectp(me.mconnection) then
    me.mconnection = new(xtra("multiuser"))
    if objectp(me.mconnection) then
      err = setnetmessagehandler(me.mconnection, #callbackhandler, script("コールバック"))
      if err = 0 then
        err = connecttonetserver(me.mconnection, " ", " ", "rs.loopit.ne.jp", 7891, " ", 1)
        if err = 0 then
          gtickcount = the ticks
          sendAllSprites(#enable)
          sendAllSprites(#ufoconnect)
        else
          me.mstatus = #未接続
          me.mconnection = 0
        end if
      end if
    else
      me.mconnection = 0
    end if
  end if
end

on disconnect me, self
  if not voidp(self) then
    me.sendstring("quit")
  else
    sendAllSprites(#closeshutter)
  end if
  me.mbuffer = []
  me.missend = 1
  me.mstatus = #未接続
  me.mconnection = 0
  me.misfirst = 1
  sendAllSprites(#disable)
  sendAllSprites(#ufodisconnect)
  installMenu(member("menu_offline"))
  repeat while not voidp(self)
    repeat with i = the windowList.count down to 1
      tmp = the windowList[i]
      if tmp.name <> "init" then
        tmp.visible = 1
        close(tmp)
      end if
      forget(tmp)
    end repeat
  end repeat
end

on getLast me
  return me.mlaststring
end

on getsend me
  return me.missend
end

on receiveok me
  me.missend = 0
  if me.misfirst then
    me.misfirst = 0
    go("login2")
  end if
end

on sendok me
  me.missend = 1
end

on getconnection me
  return me.mconnection
end

on getstatus me
  return me.mstatus
end

on setstatus me, status
  me.mstatus = status
end

on getissend me
  return me.missend
end
