property mreserve, mchatroom

on new me
  me.initialize()
  return me
end

on initialize me
  me.mreserve = []
  me.mchatroom = []
end

on addreserve me, msg
  msg.msg = replace(msg.msg, "$%0d%0a$", RETURN)
  me.mreserve.add(msg)
end

on setreserveroomid me, roomid
  lastroom = me.mreserve.getLast()
  lastroom.roomid = roomid
end

on searchreserve me, roomid
  pos = 0
  repeat with i = 1 to me.count(#mreserve)
    room = me.mreserve[i]
    if room.roomid = roomid then
      pos = i
    else
    end if
  end repeat
  return pos
end

on searchchatroom me, roomid
  pos = 0
  repeat with i = 1 to me.count(#mchatroom)
    room = me.mchatroom[i]
    if room.getroomid() = roomid then
      pos = i
    else
    end if
  end repeat
  return pos
end

on receivejoined me, msg
  pos = me.searchreserve(msg.roomid)
  if pos then
    chatroom = new(script("チャットルーム"), #自分から, msg, mreserve[pos])
    if not voidp(chatroom) then
      me.mchatroom.add(chatroom)
    end if
    mreserve.deleteAt(pos)
  else
    pos = me.searchchatroom(msg.roomid)
    if pos then
      room = mchatroom[pos]
      room.receivejoined(msg)
    end if
  end if
end

on addstatus me, msg, roomid
  pos = me.searchchatroom(roomid)
  if pos then
    room = mchatroom[pos]
    room.addstatus(msg)
  end if
end

on receivestatus me, msg
  repeat with room in me.mchatroom
    pos = room.searchmember(msg.userid)
    if pos then
      room.receivestatus(msg)
    end if
  end repeat
end

on _receivemsg me, msg
  pos = searchchatroom(me, msg.roomid)
  if pos then
    room = me.mchatroom[pos]
    room._receivemsg(msg)
  else
    chatroom = new(script("チャットルーム"), #他人から, msg)
    if not voidp(chatroom) then
      me.mchatroom.add(chatroom)
    end if
  end if
end

on receiveretired me, msg
  pos = searchchatroom(me, msg.roomid)
  if pos then
    room = me.mchatroom[pos]
    room.receiveretired(msg)
  end if
end

on sendmsg me, msg
  pos = searchchatroom(me, msg.roomid)
  if pos then
    room = me.mchatroom[pos]
    room.sendmsg(msg)
  end if
end

on closeWindow me, roomid
  pos = searchchatroom(me, roomid)
  if pos then
    room = me.mchatroom[pos]
    room = 0
    mchatroom.deleteAt(pos)
  end if
end

on addpublic me, msg, name
  pos = searchchatroom(me, msg.roomid)
  if pos = 0 then
    chatroom = new(script("チャットルーム"), #パブリック, msg, name)
    if not voidp(chatroom) then
      me.mchatroom.add(chatroom)
    end if
  end if
end

on getchattype me, roomid
  pos = searchchatroom(me, roomid)
  if pos then
    chatroom = me.mchatroom[pos]
    chattype = chatroom.getchattype()
    return chattype
  end if
end

on setskin me
  repeat with i in me.mchatroom
    i.setskin()
  end repeat
end

on _getprop me, roomid, userid
  pos = searchchatroom(me, roomid)
  if pos then
    chatroom = me.mchatroom[pos]
    return chatroom._getprop(userid)
  end if
end

on getnumofpublicrooms me
  cnt = 0
  repeat with i in me.mchatroom
    if i.getchattype() = #パブリック then
      cnt = cnt + 1
    end if
  end repeat
  return cnt
end
