property msearchtype, msearchid, mhit, msearchresult, marealist, missearching
global gconnection

on new me
  me.marealist = []
  me.missearching = 0
  return me
end

on sendsearch me, msg
  if msg.option <> #close then
    me.msearchresult = []
    me.msearchtype = msg.option
    me.missearching = 1
  end if
end

on receivestatus me, msg
  me.msearchresult.add(msg)
  if me.msearchtype = #direct then
    if windowPresent("search") then
      tell window("search")
        sendAllSprites(#updateresult, me.msearchtype, me.msearchresult)
      end tell
    end if
    me.missearching = 0
  end if
end

on receiveresult me, searchid
  me.msearchid = searchid
end

on receivehit me, hit
  me.mhit = hit
end

on receivesearchid me, searchid, searchtype
  me.msearchid = searchid
end

on receivearealist me, msg
  me.marealist.add(msg)
end

on receivelistok me
  if windowPresent("search") then
    window("search").visible = 1
  end if
end

on receiveend me
  if windowPresent("search") then
    tell window("search")
      sendAllSprites(#updateresult, me.msearchtype, me.msearchresult)
    end tell
  end if
  me.missearching = 0
end

on receiveerror me
  if windowPresent("search") then
    tell window("search")
      sendAllSprites(#updateresult, me.msearchtype, me.msearchresult)
    end tell
  end if
  me.missearching = 0
end

on openWindow me
  window("search").fileName = the moviePath & "data¥search.dir"
  window("search").windowType = 4
  window("search").title = "トモダチ検索"
  if window("search").visible = 0 then
    window("search").rect = offsetrect(window("search").rect)
  end if
  if marealist.count = 0 then
    if objectp(gconnection) then
      gconnection.send("list area")
    end if
  else
    window("search").visible = 1
  end if
  window("search").visible = 1
end

on getsearchtype me
  return me.msearchtype
end

on cancel me
  if me.missearching = 1 then
    if objectp(gconnection) then
      gconnection.send("search close" && me.msearchid)
    end if
    me.missearching = 0
  end if
end
